##PROJECT_GLOBAL_BEGIN
[Programs]
Count=1

[Misc Info]
Author=
Company=
Version=1.0
EditTime=21257
CyProVersion=3.0.3

[Protection]
Level=0
Password=
##PROJECT_GLOBAL_END

##PROGRAM_BEGIN_1
#PROJECT_OPTIONS_BEGIN
[Program]
Name=New Program

[VCP]
I2CPriority=5
SendSource=1
SendAlloc=1
ProtectWithPasswd=0
Password=
ScanOverrunStopsProgram=0
OutputRetentive=1
AutoStart=1
Com1Mode=1
Com1Baudrate=19200
Com1Data=0
Com2Mode=3
Com2Baudrate=2400
Com2Data=0
EthAbusEnable=1
EthModbusEnable=0
WANUrl=
PushEvent=0
PushUrl=my.hiq-home.com
ModbusDelay=20
ModbusDeviceAddress=1
ModbusPLCDataModel=2
ModbusAddress=0
ModbusRegisterCount=1
ModbusCoilsArrayVar=
ModbusRegistersArrayVar=
PLCCoilVars=
PLCRegisterVars=
ModbusCoilAddresses=
ModbusRegisterAddresses=

[Misc Info]
MonitorHistorySpeed=10

[Hardware]
CPUUnit=4
Card1=0
Type1=0
NAD1=0
VarPrefix1=broadcast_
Card2=60
Type2=0
NAD2=100
VarPrefix2=lc00_
Card3=60
Type3=0
NAD3=101
VarPrefix3=lc01_
Card4=60
Type4=0
NAD4=102
VarPrefix4=lc02_
Card5=60
Type5=0
NAD5=103
VarPrefix5=lc03_
Card6=61
Type6=0
NAD6=120
VarPrefix6=ld00_
Card7=61
Type7=0
NAD7=121
VarPrefix7=ld01_
Card8=61
Type8=0
NAD8=122
VarPrefix8=ld02_
Card9=61
Type9=0
NAD9=123
VarPrefix9=ld03_
Card10=63
Type10=0
NAD10=200
VarPrefix10=bc00_
Card11=63
Type11=0
NAD11=201
VarPrefix11=bc01_
Card12=64
Type12=0
NAD12=300
VarPrefix12=sc00_
Card13=64
Type13=0
NAD13=301
VarPrefix13=sc01_
Card14=64
Type14=0
NAD14=302
VarPrefix14=sc02_
Card15=64
Type15=0
NAD15=303
VarPrefix15=sc03_
Card16=9999
Type16=0
NAD16=400
VarPrefix16=th00_
Card17=9999
Type17=0
NAD17=401
VarPrefix17=th01_
Card18=9999
Type18=0
NAD18=402
VarPrefix18=th02_
Card19=9999
Type19=0
NAD19=403
VarPrefix19=th03_
Card20=9999
Type20=0
NAD20=404
VarPrefix20=th04_
Card21=67
Type21=0
NAD21=420
VarPrefix21=fc00_
Card22=67
Type22=0
NAD22=421
VarPrefix22=fc01_
Card23=67
Type23=0
NAD23=422
VarPrefix23=fc02_
Card24=67
Type24=0
NAD24=423
VarPrefix24=fc03_
Card25=67
Type25=0
NAD25=424
VarPrefix25=fc04_

[Socket00]
ID=1
SocketType=4
Descr=IQ-to-IQ sync
Var00=socket_request
Var01=socket_from
Var02=socket_to
Var03=socket_command
Var04=socket_argument_0
Var05=socket_argument_1
Var06=socket_argument_2
Var07=socket_argument_3

[Net]
PrgDevice00=17466
CurrentNAD=17466

[Monitor01]
VarCount=4
VarName1=scan_frequency
VarBase1=1
VarValue1=0
VarColor1=0
VarIndex1=0
VarName2=scan_time
VarBase2=1
VarValue2=0
VarColor2=0
VarIndex2=1
VarName3=scan_time_max
VarBase3=1
VarValue3=0
VarColor3=0
VarIndex3=2
VarName4=scan_overrun
VarBase4=1
VarValue4=0
VarColor4=0
VarIndex4=3

[Monitor02]
VarCount=8
VarName1=th00_general_error
VarBase1=1
VarValue1=0
VarColor1=0
VarIndex1=0
VarName2=th00_timeout_error
VarBase2=1
VarValue2=0
VarColor2=0
VarIndex2=1
VarName3=th01_general_error
VarBase3=1
VarValue3=0
VarColor3=0
VarIndex3=2
VarName4=th01_timeout_error
VarBase4=1
VarValue4=0
VarColor4=0
VarIndex4=3
VarName5=lc00_general_error
VarBase5=1
VarValue5=0
VarColor5=0
VarIndex5=4
VarName6=lc00_timeout_error
VarBase6=1
VarValue6=0
VarColor6=0
VarIndex6=5
VarName7=th00_setpoint
VarBase7=1
VarValue7=0
VarColor7=0
VarIndex7=6
VarName8=th00_selected
VarBase8=1
VarValue8=0
VarColor8=0
VarIndex8=7
#PROJECT_OPTIONS_END

#DMVARSLIST_BEGIN
#DMVARSLIST_END

#MASKS_BEGIN
#MASKS_END

#CODE_BEGIN
// AllocGroupList="User Variables", "Lights", "Remote", "Scene", "Hvac", "Timetable", "Presence", "LowLight", "Automation", "Alarm", "Energy", "Devices", "Socket", "System", "Constants", "I/O Variables"
var retain
  evo_light_enable: ARRAY[0..3] OF bool; // When enabled, RGB will output a cold white light during day, but warm during evening and night. Hue and saturation are controlled automatically, user controls brightness. {AllocGroup="Lights"}
  evo_light_start_hue: ARRAY[0..3] OF int; default=50; // Hue setting for daylight. Default value is 50, corresponding to light temperature of about 5600K. {AllocGroup="Lights"}
  evo_light_end_hue: ARRAY[0..3] OF int; default=10; // Hue setting for warm evening light. Default value is 10, corresponding to light temperature of about 2000K. {AllocGroup="Lights"}
  evo_light_saturation: ARRAY[0..3] OF int; default=50; // Saturation setting during evo light. Default value of 50 engage both RGB and white channels, which usually produce the most natural light. {AllocGroup="Lights"}
  evo_light_start: ARRAY[0..3] OF int; default=22; // Time when transition to warm light begins (0..23) [hour]. {AllocGroup="Lights"}
  reset_counter: int; // Total number of controller resets. {AllocGroup="System"}
  hvac_mode: int; // Hvac mode: 0-off, 1-heating, 2-cooling. {AllocGroup="Hvac"}
  timetable_0_array: ARRAY[0..335] OF bool; // Weekly scheduler. From monday to sunday, half hour resolution. {AllocGroup="Timetable"}
  timetable_1_array: ARRAY[0..335] OF bool; // Weekly scheduler. From monday to sunday, half hour resolution. {AllocGroup="Timetable"}
  timetable_2_array: ARRAY[0..335] OF bool; // Weekly scheduler. From monday to sunday, half hour resolution. {AllocGroup="Timetable"}
  timetable_0_th00_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_0_th01_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_0_th02_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_0_th03_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_0_th04_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_1_th00_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_1_th01_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_1_th02_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_1_th03_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  coming_home_enable: bool; // Lights and thermostats are turned on when presence signal goes on. {AllocGroup="Automation"}
  coming_home_th00_enable: bool; // Select thermostat for comming home. {AllocGroup="Automation"}
  coming_home_th01_enable: bool; // Select thermostat for comming home. {AllocGroup="Automation"}
  coming_home_th02_enable: bool; // Select thermostat for comming home. {AllocGroup="Automation"}
  coming_home_th03_enable: bool; // Select thermostat for comming home. {AllocGroup="Automation"}
  coming_home_th04_enable: bool; // Select thermostat for comming home. {AllocGroup="Automation"}
  coming_home_scene_enable: bool; // Enable setting scene for comming home. {AllocGroup="Automation"}
  coming_home_scene_number: int; // Scene number for comming home (0..31). {AllocGroup="Automation"}
  coming_home_dark_only: bool; // Set scene and matrix only when lightness is low. {AllocGroup="Automation"}
  leaving_home_enable: bool; // Lights and themostats are turned off when presence signal goes off. {AllocGroup="Automation"}
  leaving_home_th00_enable: bool; // Select thermostat for leaving home. {AllocGroup="Automation"}
  leaving_home_th01_enable: bool; // Select thermostat for leaving home. {AllocGroup="Automation"}
  leaving_home_th02_enable: bool; // Select thermostat for leaving home. {AllocGroup="Automation"}
  leaving_home_th03_enable: bool; // Select thermostat for leaving home. {AllocGroup="Automation"}
  leaving_home_th04_enable: bool; // Select thermostat for leaving home. {AllocGroup="Automation"}
  leaving_home_scene_enable: bool; // Enable setting scene for leaving home. {AllocGroup="Automation"}
  leaving_home_scene_number: int; // Scene number for leaving home (0..31). {AllocGroup="Automation"}
  leaving_home_dark_only: bool; // Set scene and matrix only when lightness is low. {AllocGroup="Automation"}
  smart_lights_enable: bool; // Activate lights when low light goes on, and presence is active at the same tome. {AllocGroup="Automation"}
  smart_lights_scene_enable: bool; // When enabled, scene will be activated (0-off, 1-on). {AllocGroup="Automation"}
  smart_lights_scene_on_number: int; // Scene number for turning lights on (0..31). {AllocGroup="Automation"}
  smart_lights_scene_off_number: int; // Scene number for turning lights off (0..31). {AllocGroup="Automation"}
  smart_lights_dimmer_enable: bool; // When enabled, dimmer will turn on gradually (0-off, 1-on). {AllocGroup="Automation"}
  smart_lights_dimmer_time: int; default=30; // Transition time from zero to final brightness [min]. When time is zero, dimmer will turn on instantly. {AllocGroup="Automation"}
  smart_lights_dimmer_number: int; // Dimmer number (0..15). {AllocGroup="Automation"}
  smart_lights_dimmer_setpoint: int; default=100; // Final brightness (0..100%). {AllocGroup="Automation"}
  random_lights_enable: bool; // Automatically run lights to prevent burglary. Select one of three scene by random, activated in a random period (15-60 minutes). Run condition is presence off and low light on. {AllocGroup="Automation"}
  random_lights_scene: ARRAY[0..2] OF int; // Scenes for random lights (0..31). {AllocGroup="Automation"}
  comfort_wake_up_enable: bool; // Turn thermostat on a predefined number of minutes before smartphone alarm is activated. {AllocGroup="Automation"}
  comfort_wake_up_th00_enable: bool; // Select thermostat for comfort wake up. {AllocGroup="Automation"}
  comfort_wake_up_th01_enable: bool; // Select thermostat for comfort wake up. {AllocGroup="Automation"}
  comfort_wake_up_th02_enable: bool; // Select thermostat for comfort wake up. {AllocGroup="Automation"}
  comfort_wake_up_th03_enable: bool; // Select thermostat for comfort wake up. {AllocGroup="Automation"}
  comfort_wake_up_th04_enable: bool; // Select thermostat for comfort wake up. {AllocGroup="Automation"}
  comfort_wake_up_scene_enable: bool; // Enable setting scene for comfort wake up. {AllocGroup="Automation"}
  comfort_wake_up_scene_number: int; // Scene number for comfort wake up (0..31). {AllocGroup="Automation"}
  comfort_wake_up_dark_only: bool; // Set scene and matrix only when lightness is low. {AllocGroup="Automation"}
  sunny_wake_up_enable: bool; // Lift blinds a predefined number of minutes before smartphone alarm is activated. {AllocGroup="Automation"}
  sunny_wake_up_blinds_number: int; // Blinds number for sunny wake up (0..9). {AllocGroup="Automation"}
  sunny_wake_up_setpoint: int; // Position where blinds must go, 0..100% (0-top, 100-bottom). {AllocGroup="Automation"}
  sunny_wake_up_gradually: bool; // When enabled, blinds will move gradually, full swing in about half hour. {AllocGroup="Automation"}
  default_setpoint_enable: bool; // When active, any heating/cooling adjustment will be valid for about one hour, then it will return to the predefined temperature. {AllocGroup="Automation"}
  default_setpoint_th00_enable: bool; // Enable predefined temperature. {AllocGroup="Automation"}
  default_setpoint_th01_enable: bool; // Enable predefined temperature. {AllocGroup="Automation"}
  default_setpoint_th02_enable: bool; // Enable predefined temperature. {AllocGroup="Automation"}
  default_setpoint_th03_enable: bool; // Enable predefined temperature. {AllocGroup="Automation"}
  default_setpoint_th04_enable: bool; // Enable predefined temperature. {AllocGroup="Automation"}
  default_setpoint_th00: int; // Predefined setpoint temperature [*0.1C]. {AllocGroup="Automation"}
  default_setpoint_th01: int; // Predefined setpoint temperature [*0.1C]. {AllocGroup="Automation"}
  default_setpoint_th02: int; // Predefined setpoint temperature [*0.1C]. {AllocGroup="Automation"}
  default_setpoint_th03: int; // Predefined setpoint temperature [*0.1C]. {AllocGroup="Automation"}
  default_setpoint_th04: int; // Predefined setpoint temperature [*0.1C]. {AllocGroup="Automation"}
  bio_offset_enable: bool; // Daily temperature profile, used to gratify natural biological rhythm (chronotype). Temperature is adjusted according to the time of a day, in two-hour intervals. {AllocGroup="Automation"}
  bio_offset_array: ARRAY[0..11] OF int; // Deviation from setpoint, two hour steps [*0.1C]. {AllocGroup="Automation"}
  latitude: int; // Geographic latitude, + north, - south [deg]. {AllocGroup="LowLight", user}
  longitude: int; // Geographic longitude, + east, - west [deg]. {AllocGroup="LowLight", user}
  time_zone: int; // Difference between local and UTC time, including daylight saving, + east, - west [hours]. {AllocGroup="LowLight", user}
  local_offset: int; // Sunrise/sunset correction [minutes]. Positive value move sunrise later and sunset earlier. {AllocGroup="LowLight", user}
  light_sensor_enable: bool; // Use light sensor to activate low light indicator on particulary dark days. {AllocGroup="LowLight", user}
  light_sensor_threshold: int; // Lightness level where low light indicator is activated. {AllocGroup="LowLight", user}
  scene_memory: ARRAY[0..2239] OF int; // Soft scene memory array (-1-not affected, 0-off, 1..100-level). Cell index is [module type] x [module number] x [output number] x [scene number 0..31]. {AllocGroup="Scene"}
  input_scene_array: ARRAY[0..39] OF int; // Scene number for the corresponding input (0..31). {AllocGroup="Scene"}
  evo_light_time: ARRAY[0..3] OF int; default=60; // Transition time from cold to warm light [min]. {AllocGroup="Lights"}
  color_cycling_enable: ARRAY[0..3] OF bool; // Automatic color cycling (0-off, 1-on). {AllocGroup="Lights"}
  color_cycling_period: ARRAY[0..3] OF int; default=60; // Period of color cycling, given in seconds. {AllocGroup="Lights"}
  device_slow_change: bool; // Dimming rate (0-quick, 1-slow). {AllocGroup="Devices"}
  device_lightness_day: int; default=100; // Display brightness on daylight: 0-off, 255-maximum. {AllocGroup="Devices"}
  device_lightness_night: int; default=1; // Display brightness in darkness: 0-off, 255-maximum. {AllocGroup="Devices"}
  device_backlight_enable: bool; default=1; // Weak nightly illumination: 0-off, 1-on. {AllocGroup="Devices"}
  device_beep_enable: bool; // Short beep when IR command is received. {AllocGroup="Devices"}
  timetable_1_th04_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_2_th00_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_2_th01_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_2_th02_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_2_th03_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  timetable_2_th04_enable: bool; // When enabled, timetable directly affect thermostat. {AllocGroup="Timetable"}
  th00_hysteresis: int; default=2; // Hysteresis for on/off regulation [*0.1C]. Defined as distance between on and off points. Minimum value is 0.1C. {AllocGroup="Hvac"}
  operating_hours: long; // Total number of operating hours [h]. {AllocGroup="System"}
  retentive_magic: long; // Magic value to detect that retentive memory is erased. {AllocGroup="System"}
  autoaddress_timer: int; // Countdown timer for autoaddressing. Retentive to survive power supply droputs which may be caused by turning devices on and off. {AllocGroup="System"}
  push_enable: bool; // Allow controller to send periodical push messages to server: 0-off, 1-on. {AllocGroup="System"}
  output_power_count: ARRAY[0..55] OF long; // How many times output is turned on. {AllocGroup="Energy"}
  output_nominal_power: ARRAY[0..55] OF int; // Load connected to specified output [W]. {AllocGroup="Energy"}
  output_operating_hours: ARRAY[0..55] OF int; // Total operating hours [h]. {AllocGroup="Energy"}
  output_operating_seconds: ARRAY[0..55] OF int; // Prescaler for operating hours [s]. {AllocGroup="Energy"}
  output_energy_today: ARRAY[0..55] OF int; // Total energy consumption today [Wh]. {AllocGroup="Energy"}
  output_energy_total: ARRAY[0..55] OF int; // Total energy consumption per output [kWh]. {AllocGroup="Energy"}
  energy_consumption_by_hour: ARRAY[0..23] OF int; // Energy consumption in last 24 hours [kWh]. {AllocGroup="Energy"}
  energy_sample_last_hour: long; // Power meter energy before one hour [kWh]. {AllocGroup="Energy"}
  connect_charger_th00_enable: bool; // Select thermostat for connecting charger. {AllocGroup="Automation"}
  connect_charger_th01_enable: bool; // Select thermostat for connecting charger. {AllocGroup="Automation"}
  connect_charger_th02_enable: bool; // Select thermostat for connecting charger. {AllocGroup="Automation"}
  alarm_state: int; // Alarm state: 0-off, 1-arming, 2-armed, 3-activating, 4-active, 5-expired. {AllocGroup="Alarm"}
  alarm_zone_enable: ARRAY[0..3] OF bool; // Zone enable. Each zone have up to 3 sensors: zone 0 use sensors 0..2, zone 1 sensors 3..5, zone 2 sensors 6..8, and zone 3 sensors 9..11. {AllocGroup="Alarm"}
  alarm_sensor_enable: ARRAY[0..11] OF bool; // Alarm sensor enable. {AllocGroup="Alarm"}
  alarm_sensor_instant: ARRAY[0..11] OF bool; // When enabled, sensor immediately activate alarm, ignoring delay time. {AllocGroup="Alarm"}
  alarm_sensor_position: ARRAY[0..11] OF int; // Configured alarm sensor position (0..39). {AllocGroup="Alarm"}
  alarm_arming_time: int; default=30; // Configured delay from alarm on to alarm armed [s]. {AllocGroup="Alarm"}
  th01_hysteresis: int; default=2; // Hysteresis for on/off regulation [*0.1C]. Defined as distance between on and off points. Minimum value is 0.1C. {AllocGroup="Hvac"}
  th02_hysteresis: int; default=2; // Hysteresis for on/off regulation [*0.1C]. Defined as distance between on and off points. Minimum value is 0.1C. {AllocGroup="Hvac"}
  th03_hysteresis: int; default=2; // Hysteresis for on/off regulation [*0.1C]. Defined as distance between on and off points. Minimum value is 0.1C. {AllocGroup="Hvac"}
  th04_hysteresis: int; default=2; // Hysteresis for on/off regulation [*0.1C]. Defined as distance between on and off points. Minimum value is 0.1C. {AllocGroup="Hvac"}
  push_req_counter: long; // Number of push messages sent. Program is configured to send push periodically, once a minute. {AllocGroup="System"}
  push_ack_counter: long; // Number of received acknowledges. Acknowledge confirms that connection to server work in both directions. {AllocGroup="System"}
  alarm_delay_time: int; default=30; // Configured delay from sensor active to alarm active [s]. {AllocGroup="Alarm"}
  alarm_active_time: int; default=120; // Configured time, how long the alarm output will be active [s]. {AllocGroup="Alarm"}
  alarm_output_position: int; // Configured alarm output, output number where alarm horn is connected (0..39). {AllocGroup="Alarm"}
  alarm_scene_enable: bool; // If enabled, alarm activation will also set a specified scene. {AllocGroup="Alarm"}
  alarm_scene_number: int; // Scene number to set when alarm is activated. {AllocGroup="Alarm"}
  alarm_auto_arming: bool; // Use presence signal to automatically turn alarm on/off. {AllocGroup="Alarm"}
  alarm_code_enable: bool; // Pin code required to turn alarm on/off with HIQ Configurator. Used to prevent burglar to turn alarm off. {AllocGroup="Alarm"}
  alarm_code_memory: int; default=1234; // Configured code used to to turn alarm on/off (0..9999). {AllocGroup="Alarm"}
  alarm_indicator_enable: bool; // Use an output to indicate alarm state: off, blink (arming/activating/active), on (armed). {AllocGroup="Alarm"}
  alarm_indicator_position: int; // Output number for alarm indicator (0..39). {AllocGroup="Alarm"}
  th00_demand_enable: bool; // Enable thermostat to control energy source: 0-off, 1-on. {AllocGroup="Hvac"}
  th01_demand_enable: bool; // Enable thermostat to control energy source: 0-off, 1-on. {AllocGroup="Hvac"}
  th02_demand_enable: bool; // Enable thermostat to control energy source: 0-off, 1-on. {AllocGroup="Hvac"}
  th03_demand_enable: bool; // Enable thermostat to control energy source: 0-off, 1-on. {AllocGroup="Hvac"}
  alarm_indicator_blink: bool; // Instead of state indicator, just blink an existing output a few times, to indicate that alarm is turned on/off. {AllocGroup="Alarm"}
  timetable_0_output_enable: bool; // When enabled, timetable will set the selected output. {AllocGroup="Timetable"}
  timetable_0_output_number: int; // Output controlled by timetable (0..55). {AllocGroup="Timetable"}
  timetable_0_scene_enable: bool; // When enabled, timetable will set the selected scene. {AllocGroup="Timetable"}
  timetable_0_scene_on_number: int; // Scene number when timetable is on (0..31). {AllocGroup="Timetable"}
  timetable_0_scene_off_number: int; // Scene number when timetable is off (0..31). {AllocGroup="Timetable"}
  th04_demand_enable: bool; // Enable thermostat to control energy source: 0-off, 1-on. {AllocGroup="Hvac"}
  energy_delay: int; default=60; // Time from thermost request to boiler/chiller activation [s]. Used to delay activation until actuator valve is fully open. {AllocGroup="Hvac"}
  outdoor_temperature_enable: bool; // Enable outdoor temperature measurement: 0-off, 1-on. {AllocGroup="Hvac"}
  outdoor_temperature_source: int; // Outdoor temperature sensor position: 0-TH0, 1-TH1, 2-TH2, 3-TH3, 4-TH4. {AllocGroup="Hvac"}
  wall_temperature_enable: bool; // Enable wall temperature measurement: 0-off, 1-on. {AllocGroup="Hvac"}
  wall_temperature_source: int; // Wall temperature sensor position: 0-TH0, 1-TH1, 2-TH2, 3-TH3, 4-TH4. {AllocGroup="Hvac"}
  water_temperature_enable: bool; // Enable water temperature measurement: 0-off, 1-on. {AllocGroup="Hvac"}
  water_temperature_source: int; // Water temperature sensor position: 0-TH0, 1-TH1, 2-TH2, 3-TH3, 4-TH4. {AllocGroup="Hvac"}
  auxilary_temperature_enable: bool; // Enable auxilary temperature measurement: 0-off, 1-on. {AllocGroup="Hvac"}
  auxilary_temperature_source: int; // Auxilary temperature sensor position: 0-TH0, 1-TH1, 2-TH2, 3-TH3, 4-TH4. {AllocGroup="Hvac"}
  energy_consumption_by_day: ARRAY[0..29] OF int; // Energy consumption in last 30 days [kWh]. {AllocGroup="Energy"}
  energy_sample_last_day: long; // Power meter energy before one day [kWh]. {AllocGroup="Energy"}
  connect_charger_th03_enable: bool; // Select thermostat for connecting charger. {AllocGroup="Automation"}
  connect_charger_th04_enable: bool; // Select thermostat for connecting charger. {AllocGroup="Automation"}
  connect_charger_scene_enable: bool; // Enable setting scene for connecting charger. {AllocGroup="Automation"}
  connect_charger_scene_number: int; // Scene number for connecting charger (0..31). {AllocGroup="Automation"}
  connect_charger_dark_only: bool; // Set scene and matrix only when lightness is low. {AllocGroup="Automation"}
  disconnect_charger_th00_enable: bool; // Select thermostat for disconnecting charger. {AllocGroup="Automation"}
  disconnect_charger_th01_enable: bool; // Select thermostat for disconnecting charger. {AllocGroup="Automation"}
  disconnect_charger_th02_enable: bool; // Select thermostat for disconnecting charger. {AllocGroup="Automation"}
  disconnect_charger_th03_enable: bool; // Select thermostat for disconnecting charger. {AllocGroup="Automation"}
  disconnect_charger_th04_enable: bool; // Select thermostat for disconnecting charger. {AllocGroup="Automation"}
  ready_light_short_timeout: ARRAY[0..3] OF int; default=10; // Configured period, door closed to light off [s]. {AllocGroup="Lights", user}
  ready_light_long_timeout: ARRAY[0..3] OF int; default=300; // Configured period, door open to light off [s]. {AllocGroup="Lights", user}
  disconnect_charger_scene_enable: bool; // Enable setting scene for disconnecting charger. {AllocGroup="Automation"}
  disconnect_charger_scene_number: int; // Scene number for disconnecting charger (0..31). {AllocGroup="Automation"}
  ready_light_enable: ARRAY[0..3] OF bool; // General enable for automatic operation. When disabled, light can still be used with a button. {AllocGroup="Lights", user}
  ready_light_pir_position: ARRAY[0..3] OF int; // Configured position of PIR sensor [0..39]. {AllocGroup="Lights", user}
  ready_light_reed_position: ARRAY[0..3] OF int; // Configured position of reed switch [0..39]. {AllocGroup="Lights", user}
  ready_light_output_position: ARRAY[0..3] OF int; // Configured output position [0..39]. On/off button is connected to related input. {AllocGroup="Lights", user}
  disconnect_charger_dark_only: bool; // Set scene and matrix only when lightness is low. {AllocGroup="Automation"}
  call_notification_enable: bool; // Blink light a few times to notify an incomming call (0-off, 1-on). {AllocGroup="Automation"}
  presence_phone_enable: bool; // Use smartphone wi-fi connection to automatically turn presence signal on/off. {AllocGroup="Presence"}
  presence_timeout: int; default=300; // Configured value for presence timeout [s]. {AllocGroup="Presence"}
  presence_on_enable: bool; // External device to turn the presence signal on (e.g. numeric keylock, rfid reader, fingerprint reader). {AllocGroup="Presence"}
  presence_on_position: bool; // Input number for presence on (0..39). {AllocGroup="Presence"}
  presence_off_enable: bool; // Exteral device to turn the presence signal off (e.g. button on inner side of front door). {AllocGroup="Presence"}
  presence_off_position: int; // Input number for presence off (0..39). {AllocGroup="Presence"}
  presence_onoff_enable: bool; // External device to turn presence signal on/off (e.g. professional alarm system). {AllocGroup="Presence"}
  presence_onoff_position: int; // Input number for direct presence control (0..39). {AllocGroup="Presence"}
  presence_button_enable: bool; // Button to manually toggle presence signal on/off. {AllocGroup="Presence"}
  presence_button_position: int; // Input number where presence button is connected (0..39). {AllocGroup="Presence"}
  presence_button_longpress: bool; // When enabled, button must be held down for about 2 seconds. {AllocGroup="Presence"}
  scene_sync_enable: ARRAY[0..31] OF bool; // Scene synchronization between two or more IQ systems (0-off, 1-on). {AllocGroup="Scene"}
  call_notification_light_number: int; // Select output number for call notification (0..39). {AllocGroup="Automation"}
  ready_light_low_light_only: ARRAY[0..3] OF bool; // Configured condition, activate lights only in low light. {AllocGroup="Lights", user}
  ir_custom_enable: bool; // Enable custom configured IR codes. {AllocGroup="Remote"}
  ir_custom_array: ARRAY[0..31] OF int; // Memorized code to activate corresponding scene (0..31). {AllocGroup="Remote"}
  sc00_ir_enable: bool; // Enable IR receiver. {AllocGroup="Remote"}
  sc01_ir_enable: bool; // Enable IR receiver. {AllocGroup="Remote"}
  sc02_ir_enable: bool; // Enable IR receiver. {AllocGroup="Remote"}
  sc03_ir_enable: bool; // Enable IR receiver. {AllocGroup="Remote"}
  th00_ir_enable: bool; // Enable IR receiver. {AllocGroup="Remote"}
  th01_ir_enable: bool; // Enable IR receiver. {AllocGroup="Remote"}
  th02_ir_enable: bool; // Enable IR receiver. {AllocGroup="Remote"}
  th03_ir_enable: bool; // Enable IR receiver. {AllocGroup="Remote"}
  th04_ir_enable: bool; // Enable IR receiver. {AllocGroup="Remote"}
  timetable_1_output_enable: bool; // When enabled, timetable will set the selected output. {AllocGroup="Timetable"}
  timetable_1_output_number: int; // Output controlled by timetable (0..55). {AllocGroup="Timetable"}
  timetable_1_scene_enable: bool; // When enabled, timetable will set the selected scene. {AllocGroup="Timetable"}
  timetable_1_scene_on_number: int; // Scene number when timetable is on (0..31). {AllocGroup="Timetable"}
  timetable_1_scene_off_number: int; // Scene number when timetable is off (0..31). {AllocGroup="Timetable"}
  timetable_2_output_enable: bool; // When enabled, timetable will set the selected output. {AllocGroup="Timetable"}
  timetable_2_output_number: int; // Output controlled by timetable (0..55). {AllocGroup="Timetable"}
  timetable_2_scene_enable: bool; // When enabled, timetable will set the selected scene. {AllocGroup="Timetable"}
  timetable_2_scene_on_number: int; // Scene number when timetable is on (0..31). {AllocGroup="Timetable"}
  timetable_2_scene_off_number: int; // Scene number when timetable is off (0..31). {AllocGroup="Timetable"}
  presence_indicator_enable: bool; // Use an output to display state of presence signal. {AllocGroup="Presence"}
  presence_indicator_position: int; // Output number fot presence indicator (0..39). {AllocGroup="Presence"}
  presence_indicator_blink: bool; // Instead of state indicator, just blink an existing output a few times, to indicate that presence is turned on/off. {AllocGroup="Presence"}
  text_notification_enable: bool; // Blink light a few times to notify an incoming text message (0-off, 1-on). {AllocGroup="Automation"}
  text_notification_light_number: int; // Select output number for text notification (0..39). {AllocGroup="Automation"}
var_end;

var
  sunrise: int; // Calculated sunrise time, minute of day. {AllocGroup="LowLight"}
  sunset: int; // Calculated sunset time, minute of day. {AllocGroup="LowLight"}
  sunrise_hour: int; // Calculated sunrise time, hours. {AllocGroup="LowLight"}
  sunrise_min: int; // Calculated sunrise time, minutes. {AllocGroup="LowLight"}
  sunset_hour: int; // Calculated sunset time, hours. {AllocGroup="LowLight"}
  scene_status: ARRAY[0..31] OF bool; // Indicate status of corresponding scene (-1-not defined, 0-off, 1-on). {AllocGroup="Scene"}
  device_config_req: bool; // Set to update configuration parameters in all devices. Clears automatically. {AllocGroup="Devices"}
  th00_output: bool; // Radiator output: 0-off, 1-on. {AllocGroup="Hvac"}
  sc00_rw_status: int; // Scene controller activity indicator: 0-idle, 1-reading, 2-writing. {AllocGroup="Scene"}
  cybro_uptime: long; // Number of operating hours since power-on [h]. {AllocGroup="System"}
  cybro_serial: int; // Unique cybro serial number. {AllocGroup="System"}
  cybro_nad: int; // Current cybro A-bus address. {AllocGroup="System"}
  cybro_ip0: int; // Current cybro IP address, 1st byte. {AllocGroup="System"}
  cybro_ip1: int; // Current cybro IP address, 2nd byte. {AllocGroup="System"}
  cybro_ip2: int; // Current cybro IP address, 3rd byte. {AllocGroup="System"}
  cybro_ip3: int; // Current cybro IP address, 4th byte. {AllocGroup="System"}
  minute_of_day: int; // Minutes passed in current day, 0..1439. {AllocGroup="System"}
  day_of_year: int; // Days passed in current year, 1..366. {AllocGroup="System"}
  autoaddress_percent: int; // Autoaddress progress indicator 0..100%. {AllocGroup="System"}
  sc01_rw_status: int; // Scene controller activity indicator: 0-idle, 1-reading, 2-writing. {AllocGroup="Scene"}
  output_state_last: ARRAY[0..55] OF int; // Last output state, used to count power cycles. {AllocGroup="Energy"}
  output_moment_power: ARRAY[0..55] OF int; // Power currently used by a single output [W]. {AllocGroup="Energy"}
  output_energy_counter_ws: ARRAY[0..55] OF int; // Energy integrator, low word (0..3600 Ws). {AllocGroup="Energy"}
  program_id: int; // Identification number used for Integra IQ autodetect, must be equal 3. {AllocGroup="System"}
  version_major: int; // Program version most significant number. {AllocGroup="System"}
  sc02_rw_status: int; // Scene controller activity indicator: 0-idle, 1-reading, 2-writing. {AllocGroup="Scene"}
  sc03_rw_status: int; // Scene controller activity indicator: 0-idle, 1-reading, 2-writing. {AllocGroup="Scene"}
  scene_memory_read_req_0: bool; // Request to read scene memory from a single scene controller. {AllocGroup="Scene"}
  socket_request: bool; // {AllocGroup="Socket"}
  socket_from: int; // {AllocGroup="Socket"}
  socket_to: int; // {AllocGroup="Socket"}
  socket_command: int; // {AllocGroup="Socket"}
  socket_argument_0: int; // {AllocGroup="Socket"}
  socket_argument_1: int; // {AllocGroup="Socket"}
  socket_argument_2: int; // {AllocGroup="Socket"}
  socket_argument_3: int; // {AllocGroup="Socket"}
  scene_memory_read_req_1: bool; // Request to read scene memory from a single scene controller. {AllocGroup="Scene"}
  scene_memory_read_req_2: bool; // Request to read scene memory from a single scene controller. {AllocGroup="Scene"}
  output_energy_counter_wh: ARRAY[0..55] OF int; // Energy integrator, high word (0..1000 Wh). {AllocGroup="Energy"}
  power_meter_error: bool; // Communication status of power meter: 0-ok, 1-error. {AllocGroup="Energy"}
  power_meter_voltage: int; // Measured AC voltage [V]. {AllocGroup="Energy"}
  power_meter_power: int; // Measured power consumption [W]. {AllocGroup="Energy"}
  th01_output: bool; // Radiator output: 0-off, 1-on. {AllocGroup="Hvac"}
  th02_output: bool; // Radiator output: 0-off, 1-on. {AllocGroup="Hvac"}
  th03_output: bool; // Radiator output: 0-off, 1-on. {AllocGroup="Hvac"}
  th04_output: bool; // Radiator output: 0-off, 1-on. {AllocGroup="Hvac"}
  socket_scene_request: int; // Copy of request to set a scene (-1-idle, 0..31-scene number). {AllocGroup="Socket"}
  version_minor: int; // Program version middle number. {AllocGroup="System"}
  version_release: int; // Program version least significant number. {AllocGroup="System"}
  scene_memory_read_req_3: bool; // Request to read scene memory from a single scene controller. {AllocGroup="Scene"}
  authentification_req: bool; // Request to generate authentification code. {AllocGroup="System"}
  power_meter_energy: long; // Energy consumption total [kWh]. {AllocGroup="Energy"}
  power_meter_relative: int; // Resetable power consumption [W]. {AllocGroup="Energy"}
  alarm_arming_counter: int; // Counter for arming delay [s]. {AllocGroup="Alarm"}
  alarm_delay_counter: int; // Counter for activating delay [s]. {AllocGroup="Alarm"}
  alarm_active_counter: int; // Counter for alarm active delay [s]. {AllocGroup="Alarm"}
  alarm_onoff_req: bool; // Unconditional request to turn alarm on/off. {AllocGroup="Alarm"}
  alarm_code_request: int; // Entered alarm code (0..9999). {AllocGroup="Alarm"}
  energy_demand: bool; // Energy demand, one or more actuators need hot/cold water: 0-off, 1-on. {AllocGroup="Hvac"}
  energy_delay_counter: int; // Counter for boiler/chiller delay time [s]. {AllocGroup="Hvac"}
  energy_delay_percents: int; // Convert delay counter to percents [%]. {AllocGroup="Hvac"}
  energy_output: bool; // Output to boiler or chiller, lagged by configured delay time: 0-off, 1-on. {AllocGroup="Hvac"}
  boiler_output: bool; // Output for starting boiler: 0-off, 1-on. {AllocGroup="Hvac"}
  chiller_output: bool; // Output for starting chiller: 0-off, 1-on. {AllocGroup="Hvac"}
  hvac_temperature_source: int; // Select temperature source: 0-internal, 1-external, 2-remote from controller. {AllocGroup="Hvac"}
  hvac_display_mode: int; // What to display when thermostat is off: 0-nothing, 1-dashes, 2-temperature. {AllocGroup="Hvac"}
  hvac_fan_option_b01: bool; // Enable fan speed auto 1. {AllocGroup="Hvac"}
  hvac_fan_option_b02: bool; // Enable fan speed auto 2. {AllocGroup="Hvac"}
  hvac_fan_option_b03: bool; // Enable fan speed auto 3. {AllocGroup="Hvac"}
  hvac_fan_option_b04: bool; // Enable fan speed max. {AllocGroup="Hvac"}
  th00_options_back_req: bool; // Request to read options back from thermostat. {AllocGroup="Hvac"}
  th01_options_back_req: bool; // Request to read options back from thermostat. {AllocGroup="Hvac"}
  th02_options_back_req: bool; // Request to read options back from thermostat. {AllocGroup="Hvac"}
  th03_options_back_req: bool; // Request to read options back from thermostat. {AllocGroup="Hvac"}
  power_meter_reference: int; // Reference value for relative power meter [W]. {AllocGroup="Energy"}
  power_meter_reset_req: bool; // Request to reset relative power meter. {AllocGroup="Energy"}
  nominal_power_setting: int; // Temporary value for nominal power [W]. {AllocGroup="Energy"}
  energy_per_output_req: int; // Request for action: 1-reset power counter, 2-reset working hours, 3-reset energy, 4-set nominal power. {AllocGroup="Energy"}
  th04_options_back_req: bool; // Request to read options back from thermostat. {AllocGroup="Hvac"}
  th_options_timer: int; // Timer for read/write indicators [*0.1s]. {AllocGroup="Hvac"}
  th00_rw_indicator: int; // Thermostat read/write indicator: 0-idle, 1-reading, 2-writing. {AllocGroup="Hvac"}
  th01_rw_indicator: int; // Thermostat read/write indicator: 0-idle, 1-reading, 2-writing. {AllocGroup="Hvac"}
  th02_rw_indicator: int; // Thermostat read/write indicator: 0-idle, 1-reading, 2-writing. {AllocGroup="Hvac"}
  th03_rw_indicator: int; // Thermostat read/write indicator: 0-idle, 1-reading, 2-writing. {AllocGroup="Hvac"}
  th04_rw_indicator: int; // Thermostat read/write indicator: 0-idle, 1-reading, 2-writing. {AllocGroup="Hvac"}
  outdoor_temperature: int; // Measured outdoor temperature [*0.1C]. {AllocGroup="Hvac"}
  wall_temperature: int; // Measured temperature within building construction [*0.1C]. {AllocGroup="Hvac"}
  water_temperature: int; // Measured temperature of heating/cooling medium [*0.1C]. {AllocGroup="Hvac"}
  auxilary_temperature: int; // Measured temperature of auxilary sensor [*0.1C]. {AllocGroup="Hvac"}
  authentification_timer: int; // Timer fot authentification code to expire [s]. {AllocGroup="System"}
  authentification_code: long; // Random generated code used to authentificate cybro to server. {AllocGroup="System"}
  push_timer: int; // Timer for periodically sending push message [s]. {AllocGroup="System"}
  push_req: bool; // Set to send push message and start timer. {AllocGroup="System"}
  push_status: int; // Push status: 0-idle, 1-waiting, 2-ok, 3-error. {AllocGroup="System"}
  push_roundtrip: int; // Time from sending push message to receiving acknowledge [ms]. {AllocGroup="System"}
  can_rx_error_counter_max: int; // Maximum value of can receive counter. {AllocGroup="System"}
  can_tx_error_counter_max: int; // Maximum value of can transmit counter. {AllocGroup="System"}
  ready_light_state: ARRAY[0..3] OF int; // Room status: 0-empty, 1-door open, 2-unknown, 3-populated. {AllocGroup="Lights"}
  sunset_min: int; // Calculated sunset time, minutes. {AllocGroup="LowLight"}
  ready_light_pir_sensor: ARRAY[0..3] OF bool; // PIR sensor state in last scan: 0-idle, 1-active. {AllocGroup="Lights"}
  ready_light_door_open: ARRAY[0..3] OF bool; // Reed switch position in last scan: 0-door closed, 1-door open {AllocGroup="Lights"}
  ready_light_timer: ARRAY[0..3] OF int; // Timer for ready light function [s]. {AllocGroup="Lights"}
  ready_light_output_state: ARRAY[0..3] OF bool; // Output state, 0-off, 1-on. {AllocGroup="Lights"}
  coming_home_test_req: bool; // Set to test comming home event. {AllocGroup="Automation"}
  leaving_home_test_req: bool; // Set to test leaving home event. {AllocGroup="Automation"}
  global_toggle_request: int; // Request to toggle specified output (-1-idle, 0..55-output number).
  global_blink_request: int; // Request to blink specified output a few times (-1-idle, 0..55-output number).
  global_scene_request: int; // Global request to set a scene (-1-idle, 0..31-scene number).
  global_scene_no_inverse: bool; // When processing global scene request, don't apply inverse scene. Used when scene is set automatically.
  global_scene_no_resend: bool; // When processing global scene request, don't send back to network. Used by socket interface.
  global_memory_request: int; // Global request to memorize scene (-1-idle, 0..31-scene number). Only value is memorized, presence information is not changed.
  presence_indicator: bool; // Indicate that tenants are at home (0-no, 1-yes). Calculated using all possible sources. Used by automation algorithms.
  sunny_wake_up_active: bool; // Blinds moving procedure active (0-off, 1-on). {AllocGroup="Automation"}
  sunny_wake_up_position: int; // Current position of blinds selected for sunny wake up (0..100%). {AllocGroup="Automation"}
  smart_lights_active: bool; // Gradual light-up procedure active (0-off, 1-on). {AllocGroup="Automation"}
  smart_lights_counter: int; // Number of seconds for 1% increment [s]. {AllocGroup="Automation"}
  smart_lights_brightness: int; // Current brightness (0..100%). {AllocGroup="Automation"}
  smart_lights_test_req: bool; // Set to test smart lights event. {AllocGroup="Automation"}
  random_lights_test_req: bool; // Request for a next random scene, used to test random lights. {AllocGroup="Automation"}
  th00_setpoint_timeout: int; // Minutes before setpoint returns to default value. {AllocGroup="Automation"}
  th01_setpoint_timeout: int; // Minutes before setpoint returns to default value. {AllocGroup="Automation"}
  th02_setpoint_timeout: int; // Minutes before setpoint returns to default value. {AllocGroup="Automation"}
  scene_memory_write_req_0: bool; // Request to write scene memory to a single scene controller. {AllocGroup="Scene"}
  scene_memory_write_req_1: bool; // Request to write scene memory to a single scene controller. {AllocGroup="Scene"}
  scene_memory_write_req_2: bool; // Request to write scene memory to a single scene controller. {AllocGroup="Scene"}
  scene_memory_write_req_3: bool; // Request to write scene memory to a single scene controller. {AllocGroup="Scene"}
  scene_memory_reset_req: bool; // Request to erase the whole scene memory array. {AllocGroup="Scene"}
  test_output_number: int; // Output number used to test setup (0..55). {AllocGroup="Scene"}
  test_output_toggle_req: bool; // Request to toggle test output. {AllocGroup="Scene"}
  test_scene_number: int; // Scene number used to test setup (0..31). {AllocGroup="Scene"}
  test_scene_req: bool; // Request to activate test scene. {AllocGroup="Scene"}
  scene_layout: int; // Temporary holder for scene controller layout. {AllocGroup="Scene"}
  scene_button_function: ARRAY[0..3] OF int; // Temporary holder for button function: 0-on/off, 1-dimmer, 2-blinds, 3-scene. {AllocGroup="Scene"}
  th03_setpoint_timeout: int; // Minutes before setpoint returns to default value. {AllocGroup="Automation"}
  scene_button_argument: ARRAY[0..3] OF int; // Temporary holder for button argument: on/off-0..31, dimmer-0..15, blinds-0..9, scene-0..3. {AllocGroup="Scene"}
  th04_setpoint_timeout: int; // Minutes before setpoint returns to default value. {AllocGroup="Automation"}
  low_light_indicator: bool; // Indicator that lightness level is low, so automatic lights are allowed to engage (0-light level high, 1-light level low).
  ir_command: int; // IR command combined from all receivers. When action is performed, code is reset. {AllocGroup="Remote"}
  ir_command_copy: int; // Last received IR command, used for memorizing. {AllocGroup="Remote"}
  ir_memory_req: int; // Request to memorize received IR command (0..31). {AllocGroup="Remote"}
  ir_custom_reset_req: bool; // Request to erase custom IR memory. {AllocGroup="Remote"}
  smartphone_precede_event: bool; // Event triggered a few minutes before the alarm clock. Set by phone, reset by cybro. {AllocGroup="Automation"}
  smartphone_precede_minutes: int; // Number of minutes between precede and alarm. Written by phone, together with precede event. {AllocGroup="Automation"}
  smartphone_alarm_event: bool; // Event triggered when alarm clock is activated. Set by phone, reset by cybro. {AllocGroup="Automation"}
  smartphone_home_event: bool; // Event triggered when home network is connected. Set by phone, reset by cybro. {AllocGroup="Automation"}
  smartphone_presence_signal: bool; // Signal sent once in a minute, used to reload presence timeout. Set by phone, reset by cybro. {AllocGroup="Automation"}
  presence_counter: int; // Working timer for home presence. Reloaded each time smartphone presence event is received. Count down by seconds. {AllocGroup="Presence"}
  presence_percent: int; // Presence counter in percents [%]. {AllocGroup="Presence"}
  smartphone_charge_on_event: bool; // Event triggered when charger is connected. Set by phone, reset by cybro. {AllocGroup="Automation"}
  smartphone_charge_off_event: bool; // Event triggered when charger is disconnected. Set by phone, reset by cybro. {AllocGroup="Automation"}
  smartphone_call_event: bool; // Event triggered when call is received. Set by phone, reset by cybro. {AllocGroup="Automation"}
  smartphone_text_event: bool; // Event triggered when text message is received. Set by phone, reset by cybro. {AllocGroup="Automation"}
  color_cycle_position: ARRAY[0..3] OF long; // Position within rgb cycle given as time [*0.1s]. {AllocGroup="Lights"}
  color_cycle_direction: ARRAY[0..3] OF bool; // Color cycling current direction (0-dn, 1-up). {AllocGroup="Lights"}
var_end;

function main:void; language 'Structured Text';
  function clear_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var constant
    ERR = 2; // Value for non-existing output.
  var_end;

  begin
    
    // light controller
    
    if lc00_general_error then
      lc00_qx00:=bit(ERR); lc00_qx01:=bit(ERR); lc00_qx02:=bit(ERR); lc00_qx03:=bit(ERR); lc00_qx04:=bit(ERR);
      lc00_qx05:=bit(ERR); lc00_qx06:=bit(ERR); lc00_qx07:=bit(ERR); lc00_qx08:=bit(ERR); lc00_qx09:=bit(ERR);
      lc00_iex_card_id:=0; lc00_firmware_version:=0; lc00_iex_power_supply:=0;
    end_if;
    
    if lc01_general_error then
      lc01_qx00:=bit(ERR); lc01_qx01:=bit(ERR); lc01_qx02:=bit(ERR); lc01_qx03:=bit(ERR); lc01_qx04:=bit(ERR);
      lc01_qx05:=bit(ERR); lc01_qx06:=bit(ERR); lc01_qx07:=bit(ERR); lc01_qx08:=bit(ERR); lc01_qx09:=bit(ERR);
      lc01_iex_card_id:=0; lc01_firmware_version:=0; lc01_iex_power_supply:=0;
    end_if;
    
    if lc02_general_error then
      lc02_qx00:=bit(ERR); lc02_qx01:=bit(ERR); lc02_qx02:=bit(ERR); lc02_qx03:=bit(ERR); lc02_qx04:=bit(ERR);
      lc02_qx05:=bit(ERR); lc02_qx06:=bit(ERR); lc02_qx07:=bit(ERR); lc02_qx08:=bit(ERR); lc02_qx09:=bit(ERR);
      lc02_iex_card_id:=0; lc02_firmware_version:=0; lc02_iex_power_supply:=0;
    end_if;
    
    if lc03_general_error then
      lc03_qx00:=bit(ERR); lc03_qx01:=bit(ERR); lc03_qx02:=bit(ERR); lc03_qx03:=bit(ERR); lc03_qx04:=bit(ERR);
      lc03_qx05:=bit(ERR); lc03_qx06:=bit(ERR); lc03_qx07:=bit(ERR); lc03_qx08:=bit(ERR); lc03_qx09:=bit(ERR);
      lc03_iex_card_id:=0; lc03_firmware_version:=0; lc03_iex_power_supply:=0;
    end_if;
    
    if fn(lc00_general_error) then
      lc00_qx00:=0; lc00_qx01:=0; lc00_qx02:=0; lc00_qx03:=0; lc00_qx04:=0;
      lc00_qx05:=0; lc00_qx06:=0; lc00_qx07:=0; lc00_qx08:=0; lc00_qx09:=0;
    end_if;
    
    if fn(lc01_general_error) then
      lc01_qx00:=0; lc01_qx01:=0; lc01_qx02:=0; lc01_qx03:=0; lc01_qx04:=0;
      lc01_qx05:=0; lc01_qx06:=0; lc01_qx07:=0; lc01_qx08:=0; lc01_qx09:=0;
    end_if;
    
    if fn(lc02_general_error) then
      lc02_qx00:=0; lc02_qx01:=0; lc02_qx02:=0; lc02_qx03:=0; lc02_qx04:=0;
      lc02_qx05:=0; lc02_qx06:=0; lc02_qx07:=0; lc02_qx08:=0; lc02_qx09:=0;
    end_if;
    
    if fn(lc03_general_error) then
      lc03_qx00:=0; lc03_qx01:=0; lc03_qx02:=0; lc03_qx03:=0; lc03_qx04:=0;
      lc03_qx05:=0; lc03_qx06:=0; lc03_qx07:=0; lc03_qx08:=0; lc03_qx09:=0;
    end_if;
    
    // light dimmer
    
    if ld00_general_error then
      ld00_qx00:=bit(ERR); ld00_qx01:=bit(ERR); ld00_qx02:=bit(ERR); ld00_qx03:=bit(ERR);
      ld00_qw00:=0; ld00_qw01:=0; ld00_qw02:=0; ld00_qw03:=0;
      ld00_rgb_mode:=0;
      ld00_iex_card_id:=0; ld00_firmware_version:=0; ld00_iex_power_supply:=0;
    end_if;
    
    if ld01_general_error then
      ld01_qx00:=bit(ERR); ld01_qx01:=bit(ERR); ld01_qx02:=bit(ERR); ld01_qx03:=bit(ERR);
      ld01_qw00:=0; ld01_qw01:=0; ld01_qw02:=0; ld01_qw03:=0;
      ld01_iex_card_id:=0; ld01_firmware_version:=0; ld01_iex_power_supply:=0;
    end_if;
    
    if ld02_general_error then
      ld02_qx00:=bit(ERR); ld02_qx01:=bit(ERR); ld02_qx02:=bit(ERR); ld02_qx03:=bit(ERR);
      ld02_qw00:=0; ld02_qw01:=0; ld02_qw02:=0; ld02_qw03:=0;
      ld02_iex_card_id:=0; ld02_firmware_version:=0; ld02_iex_power_supply:=0;
    end_if;
    
    if ld03_general_error then
      ld03_qx00:=bit(ERR); ld03_qx01:=bit(ERR); ld03_qx02:=bit(ERR); ld03_qx03:=bit(ERR);
      ld03_qw00:=0; ld03_qw01:=0; ld03_qw02:=0; ld03_qw03:=0;
      ld03_iex_card_id:=0; ld03_firmware_version:=0; ld03_iex_power_supply:=0;
    end_if;
    
    if fn(ld00_general_error) then
      ld00_qx00:=0; ld00_qx01:=0; ld00_qx02:=0; ld00_qx03:=0;
    end_if;
    
    if fn(ld01_general_error) then
      ld01_qx00:=0; ld01_qx01:=0; ld01_qx02:=0; ld01_qx03:=0;
    end_if;
    
    if fn(ld02_general_error) then
      ld02_qx00:=0; ld02_qx01:=0; ld02_qx02:=0; ld02_qx03:=0;
    end_if;
    
    if fn(ld03_general_error) then
      ld03_qx00:=0; ld03_qx01:=0; ld03_qx02:=0; ld03_qx03:=0;
    end_if;
    
    // blinds controller
    
    if bc00_general_error then
      bc00_qxs00_up:=bit(ERR); bc00_qxs01_up:=bit(ERR); bc00_qxs02_up:=bit(ERR); bc00_qxs03_up:=bit(ERR); bc00_qxs04_up:=bit(ERR);
      bc00_qxs00_dn:=bit(ERR); bc00_qxs01_dn:=bit(ERR); bc00_qxs02_dn:=bit(ERR); bc00_qxs03_dn:=bit(ERR); bc00_qxs04_dn:=bit(ERR);
      bc00_blinds_setpoint_00:=0; bc00_blinds_setpoint_01:=0; bc00_blinds_setpoint_02:=0; bc00_blinds_setpoint_03:=0; bc00_blinds_setpoint_04:=0;
      bc00_blinds_position_00:=0; bc00_blinds_position_01:=0; bc00_blinds_position_02:=0; bc00_blinds_position_03:=0; bc00_blinds_position_04:=0;
      bc00_iex_card_id:=0; bc00_firmware_version:=0; bc00_iex_power_supply:=0;
    end_if;
    
    if bc01_general_error then
      bc01_qxs00_up:=bit(ERR); bc01_qxs01_up:=bit(ERR); bc01_qxs02_up:=bit(ERR); bc01_qxs03_up:=bit(ERR); bc01_qxs04_up:=bit(ERR);
      bc01_qxs00_dn:=bit(ERR); bc01_qxs01_dn:=bit(ERR); bc01_qxs02_dn:=bit(ERR); bc01_qxs03_dn:=bit(ERR); bc01_qxs04_dn:=bit(ERR);
      bc01_blinds_setpoint_00:=0; bc01_blinds_setpoint_01:=0; bc01_blinds_setpoint_02:=0; bc01_blinds_setpoint_03:=0; bc01_blinds_setpoint_04:=0;
      bc01_blinds_position_00:=0; bc01_blinds_position_01:=0; bc01_blinds_position_02:=0; bc01_blinds_position_03:=0; bc01_blinds_position_04:=0;
      bc01_iex_card_id:=0; bc01_firmware_version:=0; bc01_iex_power_supply:=0;
    end_if;
    
    if fn(bc00_general_error) then
      bc00_qxs00_up:=0; bc00_qxs01_up:=0; bc00_qxs02_up:=0; bc00_qxs03_up:=0; bc00_qxs04_up:=0;
      bc00_qxs00_dn:=0; bc00_qxs01_dn:=0; bc00_qxs02_dn:=0; bc00_qxs03_dn:=0; bc00_qxs04_dn:=0;
    end_if;
    
    if fn(bc01_general_error) then
      bc01_qxs00_up:=0; bc01_qxs01_up:=0; bc01_qxs02_up:=0; bc01_qxs03_up:=0; bc01_qxs04_up:=0;
      bc01_qxs00_dn:=0; bc01_qxs01_dn:=0; bc01_qxs02_dn:=0; bc01_qxs03_dn:=0; bc01_qxs04_dn:=0;
    end_if;
    
    // scene controller
    
    if sc00_general_error then
      sc00_iex_card_id:=0;
      sc00_firmware_version:=0;
      sc00_iex_power_supply:=0;
      sc00_rw_status:=0;
    end_if;
    
    if sc01_general_error then
      sc01_iex_card_id:=0;
      sc01_firmware_version:=0;
      sc01_iex_power_supply:=0;
      sc01_rw_status:=0;
    end_if;
    
    if sc02_general_error then
      sc02_iex_card_id:=0;
      sc02_firmware_version:=0;
      sc02_iex_power_supply:=0;
      sc02_rw_status:=0;
    end_if;
    
    if sc03_general_error then
      sc03_iex_card_id:=0;
      sc03_firmware_version:=0;
      sc03_iex_power_supply:=0;
      sc03_rw_status:=0;
    end_if;
    
    // thermostat
    
    if th00_general_error then
      th00_active:=2;
      th00_setpoint:=0;
      th00_temperature:=0;
      th00_temperature_1:=0;
      th00_sensor_error:=0;
      th00_iex_power_supply:=0;
      th00_ix00:=1;
      th00_iex_card_id:=0;
      th00_firmware_version:=0;
      th00_iex_power_supply:=0;
    end_if;
    
    if th01_general_error then
      th01_active:=2;
      th01_setpoint:=0;
      th01_temperature:=0;
      th01_temperature_1:=0;
      th01_sensor_error:=0;
      th01_iex_power_supply:=0;
      th01_ix00:=1;
      th01_iex_card_id:=0;
      th01_firmware_version:=0;
      th01_iex_power_supply:=0;
    end_if;
    
    if th02_general_error then
      th02_active:=2;
      th02_setpoint:=0;
      th02_temperature:=0;
      th02_temperature_1:=0;
      th02_sensor_error:=0;
      th02_iex_power_supply:=0;
      th02_ix00:=1;
      th02_iex_card_id:=0;
      th02_firmware_version:=0;
      th02_iex_power_supply:=0;
    end_if;
    
    if th03_general_error then
      th03_active:=2;
      th03_setpoint:=0;
      th03_temperature:=0;
      th03_temperature_1:=0;
      th03_sensor_error:=0;
      th03_iex_power_supply:=0;
      th03_ix00:=1;
      th03_iex_card_id:=0;
      th03_firmware_version:=0;
      th03_iex_power_supply:=0;
    end_if;
    
    if th04_general_error then
      th04_active:=2;
      th04_setpoint:=0;
      th04_temperature:=0;
      th04_temperature_1:=0;
      th04_sensor_error:=0;
      th04_iex_power_supply:=0;
      th04_ix00:=1;
      th04_iex_card_id:=0;
      th04_firmware_version:=0;
      th04_iex_power_supply:=0;
    end_if;
    
    if fn(th00_general_error) then
      th00_active:=0;
    end_if;
    
    if fn(th01_general_error) then
      th01_active:=0;
    end_if;
    
    if fn(th02_general_error) then
      th02_active:=0;
    end_if;
    
    if fn(th03_general_error) then
      th03_active:=0;
    end_if;
    
    if fn(th04_general_error) then
      th04_active:=0;
    end_if;
    
    // fan-coil controller
    
    if fc00_general_error then
      fc00_fan_speed:=0;
      fc00_valve:=0;
      fc00_iex_card_id:=0;
      fc00_firmware_version:=0;
      fc00_iex_power_supply:=0;
    end_if;
    
    if fc01_general_error then
      fc01_fan_speed:=0;
      fc01_valve:=0;
      fc01_iex_card_id:=0;
      fc01_firmware_version:=0;
      fc01_iex_power_supply:=0;
    end_if;
    
    if fc02_general_error then
      fc02_fan_speed:=0;
      fc02_valve:=0;
      fc02_iex_card_id:=0;
      fc02_firmware_version:=0;
      fc02_iex_power_supply:=0;
    end_if;
    
    if fc03_general_error then
      fc03_fan_speed:=0;
      fc03_valve:=0;
      fc03_iex_card_id:=0;
      fc03_firmware_version:=0;
      fc03_iex_power_supply:=0;
    end_if;
    
    if fc04_general_error then
      fc04_fan_speed:=0;
      fc04_valve:=0;
      fc04_iex_card_id:=0;
      fc04_firmware_version:=0;
      fc04_iex_power_supply:=0;
    end_if;
    
    // device configuration request
    
    if device_config_req then
    
      ld00_slow_change:=device_slow_change;
      ld00_config_req:=1;
    
      ld01_slow_change:=device_slow_change;
      ld01_config_req:=1;
    
      ld02_slow_change:=device_slow_change;
      ld02_config_req:=1;
    
      ld03_slow_change:=device_slow_change;
      ld03_config_req:=1;
    
      sc00_lightness_day:=device_lightness_day;
      sc00_lightness_night:=device_lightness_night;
      sc00_backlight_enable:=device_backlight_enable;
      sc00_beep_enable:=device_beep_enable;
      sc00_config_req:=1;
    
      sc01_lightness_day:=device_lightness_day;
      sc01_lightness_night:=device_lightness_night;
      sc01_backlight_enable:=device_backlight_enable;
      sc01_beep_enable:=device_beep_enable;
      sc01_config_req:=1;
    
      sc02_lightness_day:=device_lightness_day;
      sc02_lightness_night:=device_lightness_night;
      sc02_backlight_enable:=device_backlight_enable;
      sc02_beep_enable:=device_beep_enable;
      sc02_config_req:=1;
    
      sc03_lightness_day:=device_lightness_day;
      sc03_lightness_night:=device_lightness_night;
      sc03_backlight_enable:=device_backlight_enable;
      sc03_beep_enable:=device_beep_enable;
      sc03_config_req:=1;
    
      th00_lightness_day:=device_lightness_day;
      th00_lightness_night:=device_lightness_night;
      th00_beep_enable:=device_beep_enable;
      th00_config3_req:=1;
      th00_dndmmr_enable:=0;
      th00_config4_req:=1;
    
      th01_lightness_day:=device_lightness_day;
      th01_lightness_night:=device_lightness_night;
      th01_beep_enable:=device_beep_enable;
      th01_config3_req:=1;
      th01_dndmmr_enable:=0;
      th01_config4_req:=1;
    
      th02_lightness_day:=device_lightness_day;
      th02_lightness_night:=device_lightness_night;
      th02_beep_enable:=device_beep_enable;
      th02_config3_req:=1;
      th02_dndmmr_enable:=0;
      th02_config4_req:=1;
    
      th03_lightness_day:=device_lightness_day;
      th03_lightness_night:=device_lightness_night;
      th03_beep_enable:=device_beep_enable;
      th03_config3_req:=1;
      th03_dndmmr_enable:=0;
      th03_config4_req:=1;
    
      th04_lightness_day:=device_lightness_day;
      th04_lightness_night:=device_lightness_night;
      th04_beep_enable:=device_beep_enable;
      th04_config3_req:=1;
      th04_dndmmr_enable:=0;
      th04_config4_req:=1;
    
      device_config_req:=0;
    end_if;
    
  end;
  function light_algo:void; language 'Structured Text';
  begin
    
    // color cycling
    
    if fp(color_cycling_enable[0]) then
      color_cycle_position[0]:=(long(color_cycling_period[0])*ld00_qw01)/10;
      ld00_qw00:=100;
      ld00_qw02:=100;
    end_if;
    
    if color_cycling_enable[0] and ld00_color_wheel==0 and fp(clock_100ms) then
      if color_cycle_direction[0] then
        if color_cycle_position[0]<10*long(color_cycling_period[0]) then
          color_cycle_position[0]:=color_cycle_position[0]+1;
        else
          color_cycle_direction[0]:=0;
        end_if;
      else
        if color_cycle_position[0]>0 then
          color_cycle_position[0]:=color_cycle_position[0]-1;
        else
          color_cycle_direction[0]:=1;
        end_if;
      end_if;
      ld00_qw01:=int((color_cycle_position[0]*10)/color_cycling_period[0]);
    end_if;
    
    // evo light
    
    if evo_light_enable[0] and ld00_color_wheel==1 and fn(clock_100ms) then
      if minute_of_day<sunrise then
        ld00_qw01:=evo_light_end_hue[0];
      elsif minute_of_day<evo_light_start[0]*60 then
        ld00_qw01:=evo_light_start_hue[0];
      elsif minute_of_day<evo_light_start[0]*60+evo_light_time[0] then
        ld00_qw01:=evo_light_start_hue[0]+(evo_light_end_hue[0]-evo_light_start_hue[0])*(minute_of_day-evo_light_start[0]*60)/evo_light_time[0];
      else
        ld00_qw01:=evo_light_end_hue[0];
      end_if;
      ld00_qw02:=evo_light_saturation[0];
    end_if;
    
  end;
  function input_algo:void; language 'Structured Text';
  // AllocGroupList="Scene", "User Variables"
  var static
    input_number_req: int; // Button pressed, request action. {AllocGroup="Scene"}
    lc00_old: int;
    lc01_old: int;
    lc02_old: int;
    lc03_old: int;
  var_end;

  var
    i: int;
  var_end;

    function bit_position(x:int):int; language 'Structured Text';
    begin
      
      // function bit_position(x: int):int;
      //
      // returns position of raised bit
      // if two or more bits are raised at the same time, result is -1
      
      case x of
          1: result:=0;
          2: result:=1;
          4: result:=2;
          8: result:=3;
         16: result:=4;
         32: result:=5;
         64: result:=6;
        128: result:=7;
        256: result:=8;
        512: result:=9;
      else
        result:=-1;
      end_case;
      
    end;
    function next_input_mode(x:int):int; language 'Structured Text';
    begin
      
      // take care of the order of input modes
      // 0 - 1 - 6 - 7 - 2 - 3 - 8 - 4 - 5 - 9 - 10
      
      case x of
         1: result:=6;
         7: result:=2;
         3: result:=8;
         8: result:=4;
         5: result:=9;
      else
        result:=(x+1)%11;
      end_case;
      
    end;
  begin
    
    // initialize
    
    if first_scan then
      input_number_req:=-1;
    end_if;
    
    // convert key bit to input number request (0..39)
    
    i:=lc00_ix00+2*lc00_ix01+4*lc00_ix02+8*lc00_ix03+16*lc00_ix04+32*lc00_ix05+64*lc00_ix06+128*lc00_ix07+256*lc00_ix08+512*lc00_ix09;
    if i>lc00_old then
      input_number_req:=bit_position(i and not lc00_old); // detect rising edge
    end_if;
    lc00_old:=i;
    
    i:=lc01_ix00+2*lc01_ix01+4*lc01_ix02+8*lc01_ix03+16*lc01_ix04+32*lc01_ix05+64*lc01_ix06+128*lc01_ix07+256*lc01_ix08+512*lc01_ix09;
    if i>lc01_old then
      input_number_req:=bit_position(i and not lc01_old)+10; // detect rising edge
    end_if;
    lc01_old:=i;
    
    i:=lc02_ix00+2*lc02_ix01+4*lc02_ix02+8*lc02_ix03+16*lc02_ix04+32*lc02_ix05+64*lc02_ix06+128*lc02_ix07+256*lc02_ix08+512*lc02_ix09;
    if i>lc02_old then
      input_number_req:=bit_position(i and not lc02_old)+20; // detect rising edge
    end_if;
    lc02_old:=i;
    
    i:=lc03_ix00+2*lc03_ix01+4*lc03_ix02+8*lc03_ix03+16*lc03_ix04+32*lc03_ix05+64*lc03_ix06+128*lc03_ix07+256*lc03_ix08+512*lc03_ix09;
    if i>lc03_old then
      input_number_req:=bit_position(i and not lc03_old)+30; // detect rising edge
    end_if;
    lc03_old:=i;
    
    // process input number request (0..39)
    
    if input_number_req>=0 then
      if read_input_mode(input_number_req)==7 then
        global_scene_request:=input_scene_array[input_number_req]; // activate scene
      end_if;
      input_number_req:=-1;
    end_if;
    
    // transfer low light signal to light controllers
    
    lc00_low_light_signal:=low_light_indicator;
    lc01_low_light_signal:=low_light_indicator;
    lc02_low_light_signal:=low_light_indicator;
    lc03_low_light_signal:=low_light_indicator;
    
    // input setup helper, select next input mode when requested
    
    if lc00_input_mode_req then
      lc00_input_mode_data:=next_input_mode(read_input_mode(lc00_input_mode_index));
    elsif lc01_input_mode_req then
      lc01_input_mode_data:=next_input_mode(read_input_mode(lc01_input_mode_index+10));
    elsif lc02_input_mode_req then
      lc02_input_mode_data:=next_input_mode(read_input_mode(lc02_input_mode_index+20));
    elsif lc03_input_mode_req then
      lc03_input_mode_data:=next_input_mode(read_input_mode(lc03_input_mode_index+30));
    end_if;
    
  end;
  function scene_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var static
    blink_counter: int;
    blink_channel: int;
    current_scene_index: int;
    current_output_index: int;
    scene_memory_index: int;
    current_scene_value: int;
  var_end;

  var
    scene_already_set: bool;
    i: int;
    j: int;
  var_end;

    function scene_to_layout(x:int):void; language 'Structured Text';
    begin
      
      // copy from scene_memory array to layout variables
      
      scene_layout:=scene_memory[2112+4*x];
      
      scene_button_function[0]:=scene_memory[2144+4*x];
      scene_button_function[1]:=scene_memory[2146+4*x];
      scene_button_function[2]:=scene_memory[2176+4*x];
      scene_button_function[3]:=scene_memory[2178+4*x];
      
      scene_button_argument[0]:=scene_memory[2145+4*x];
      scene_button_argument[1]:=scene_memory[2147+4*x];
      scene_button_argument[2]:=scene_memory[2177+4*x];
      scene_button_argument[3]:=scene_memory[2179+4*x];
      
    end;
    function layout_to_scene(x:int):void; language 'Structured Text';
    begin
      
      // copy from layout variables to scene_memory array
      
      scene_memory[2112+4*x]:=scene_layout;
      
      scene_memory[2144+4*x]:=scene_button_function[0];
      scene_memory[2146+4*x]:=scene_button_function[1];
      scene_memory[2176+4*x]:=scene_button_function[2];
      scene_memory[2178+4*x]:=scene_button_function[3];
      
      scene_memory[2145+4*x]:=scene_button_argument[0];
      scene_memory[2147+4*x]:=scene_button_argument[1];
      scene_memory[2177+4*x]:=scene_button_argument[2];
      scene_memory[2179+4*x]:=scene_button_argument[3];
      
    end;
  begin
    
    // initialize
    
    if first_scan then
      global_toggle_request:=-1;
      global_blink_request:=-1;
      global_scene_request:=-1;
      global_memory_request:=-1;
      th00_scene_request:=-1;
      th01_scene_request:=-1;
      th02_scene_request:=-1;
      th03_scene_request:=-1;
      th04_scene_request:=-1;
      scene_memory_read_req_0:=1;
      scene_memory_read_req_1:=1;
      scene_memory_read_req_2:=1;
      scene_memory_read_req_3:=1;
      scene_layout:=-1;
    end_if;
    
    // process global toggle request (0..55)
    
    if global_toggle_request>=0 and global_toggle_request<=55 then
      toggle_output(global_toggle_request);
      global_toggle_request:=-1;
    end_if;
    
    // process global blink request (0..55)
    
    if global_blink_request>=0 and global_blink_request<=55 then
      if fp(clock_100ms) then
        if blink_counter==0 then
          blink_counter:=20; // number of blinks * 4
          blink_channel:=global_blink_request;
        end_if;
        if blink_counter>0 then
          if (blink_counter%2)==0 then // blink period
            toggle_output(blink_channel);
          end_if;
          blink_counter:=blink_counter-1;
          if blink_counter==0 then
            global_blink_request:=-1;
          end_if;
        end_if;
      end_if;
    end_if;
    
    // process global scene request (0..31)
    
    if global_scene_request>=0 and global_scene_request<=31 then
    
      // check if scene is already set
      scene_already_set:=1;
      j:=global_scene_request;
      for i:=0 to 65 do
        if read_output(i)<>-1 and scene_memory[j]<>-1 then
          if read_output(i)<>scene_memory[j] then
            scene_already_set:=0;
            i:=65; // break
          end_if;
        end_if;
        j:=j+32;
      end_for;
    
      // apply requested scene from scene controller
      if global_scene_request<=3 and not(sc00_general_error) then
        sc00_scene_send:=global_scene_request+4*global_scene_no_inverse;
        sc00_scene_send_req:=1;
      elsif global_scene_request>=4 and global_scene_request<=7 and not(sc01_general_error) then
        sc01_scene_send:=global_scene_request-4+4*global_scene_no_inverse;
        sc01_scene_send_req:=1;
      elsif global_scene_request>=8 and global_scene_request<=11 and not(sc02_general_error) then
        sc02_scene_send:=global_scene_request-8+4*global_scene_no_inverse;
        sc02_scene_send_req:=1;
      elsif global_scene_request>=12 and global_scene_request<=15 and not(sc03_general_error) then
        sc03_scene_send:=global_scene_request-12+4*global_scene_no_inverse;
        sc03_scene_send_req:=1;
      else
        // apply requested scene from cybro
        j:=global_scene_request;
        for i:=0 to 65 do
          if scene_memory[j]<>-1 then
            if not(scene_already_set) or global_scene_no_inverse then
              write_output(i,scene_memory[j]); // set scene
            else
              write_output(i,0); // set inverse scene
            end_if;
          end_if;
          j:=j+32;
        end_for;
      end_if;
    
      // update current scene status
      scene_status[global_scene_request]:=not(scene_already_set) or global_scene_no_inverse;
    
      // send scene to other controllers
      if not(global_scene_no_resend) and (not(scene_already_set) or global_scene_no_inverse) then
        socket_scene_request:=global_scene_request;
      end_if;
    
      global_scene_request:=-1;
      global_scene_no_inverse:=0;
      global_scene_no_resend:=0;
    end_if;
    
    // process request from scene controller (0..31)
    
    if sc00_scene_receive>=0 then
      if sc00_scene_receive<=3 then
        socket_scene_request:=sc00_scene_receive;
      elsif sc00_scene_receive>=8 then
        scene_memory_read_req_0:=1; // read scene memory from controller
      end_if;
      sc00_scene_receive:=-1;
    
    elsif sc01_scene_receive>=0 then
      if sc01_scene_receive<=3 then
        socket_scene_request:=sc01_scene_receive+4;
      elsif sc01_scene_receive>=8 then
        scene_memory_read_req_1:=1; // read scene memory from controller
      end_if;
      sc01_scene_receive:=-1;
    
    elsif sc02_scene_receive>=0 then
      if sc02_scene_receive<=3 then
        socket_scene_request:=sc02_scene_receive+8;
      elsif sc02_scene_receive>=8 then
        scene_memory_read_req_2:=1; // read scene memory from controller
      end_if;
      sc02_scene_receive:=-1;
    
    elsif sc03_scene_receive>=0 then
      if sc03_scene_receive<=3 then
        socket_scene_request:=sc03_scene_receive+12;
      elsif sc03_scene_receive>=8 then
        scene_memory_read_req_3:=1; // read scene memory from controller
      end_if;
      sc03_scene_receive:=-1;
    
    end_if;
    
    // process memory request (0..31)
    
    if global_memory_request>=0 and global_memory_request<=31 then
    
      // write to cybro array
      j:=global_memory_request;
      for i:=0 to 65 do
        if scene_memory[j]<>-1 then
          scene_memory[j]:=read_output(i);
        end_if;
        j:=j+32;
      end_for;
    
      // write to scene controller
      if global_memory_request<=3 and not(sc00_general_error) then
        sc00_scene_send:=global_memory_request+8; // -0+8
        sc00_scene_send_req:=1;
      elsif global_memory_request>=4 and global_memory_request<=7 and not(sc01_general_error) then
        sc01_scene_send:=global_memory_request+4; // -4+8
        sc01_scene_send_req:=1;
      elsif global_memory_request>=8 and global_memory_request<=11 and not(sc02_general_error) then
        sc02_scene_send:=global_memory_request;   // -8+8
        sc02_scene_send_req:=1;
      elsif global_memory_request>=12 and global_memory_request<=15 and not(sc03_general_error) then
        sc03_scene_send:=global_memory_request-4; // -12+8
        sc03_scene_send_req:=1;
      end_if;
    
      global_memory_request:=-1;
    end_if;
    
    // update current scene status
    
    for i:=0 to 9 do
    
      scene_memory_index:=scene_memory_index+32;
      current_output_index:=current_output_index+1;
    
      if current_output_index>65 then
        scene_status[current_scene_index]:=bit(current_scene_value); // write calculated status
        current_scene_index:=(current_scene_index+1)%32; // next scene
        current_output_index:=0;
        scene_memory_index:=current_scene_index;
        current_scene_value:=255; // scene not defined
      end_if;
    
      if scene_memory[scene_memory_index]<>-1 then
        j:=read_output(current_output_index);
        if j<>-1 then
          if scene_memory[scene_memory_index]==j then
            if current_scene_value==255 then
              current_scene_value:=1; // scene is on
            end_if;
          else
            current_scene_value:=0; // scene is off
          end_if;
        end_if;
      end_if;
    
    end_for;
    
    // erase scene memory
    
    if scene_memory_reset_req then
      for i:=0 to 2111 do
        scene_memory[i]:=-1;
      end_for;
      scene_memory_reset_req:=0;
    end_if;
    
    // start scene memory reading
    
    if scene_memory_read_req_0 then
      if not(sc00_general_error) then
        sc00_rw_status:=1;
        sc00_config_address:=0;
        sc00_config_command:=0;
        sc00_config_command_req:=1;
      end_if;
      scene_memory_read_req_0:=0;
    end_if;
    
    if scene_memory_read_req_1 then
      if not(sc01_general_error) then
        sc01_rw_status:=1;
        sc01_config_address:=0;
        sc01_config_command:=0;
        sc01_config_command_req:=1;
      end_if;
      scene_memory_read_req_1:=0;
    end_if;
    
    if scene_memory_read_req_2 then
      if not(sc02_general_error) then
        sc02_rw_status:=1;
        sc02_config_address:=0;
        sc02_config_command:=0;
        sc02_config_command_req:=1;
      end_if;
      scene_memory_read_req_2:=0;
    end_if;
    
    if scene_memory_read_req_3 then
      if not(sc03_general_error) then
        sc03_rw_status:=1;
        sc03_config_address:=0;
        sc03_config_command:=0;
        sc03_config_command_req:=1;
      end_if;
      scene_memory_read_req_3:=0;
    end_if;
    
    // start scene memory writing
    
    if scene_memory_write_req_0 then
      if not(sc00_general_error) then
        layout_to_scene(0);
        sc00_rw_status:=2;
        sc00_config_address:=0;
        sc00_config_data_write:=scene_memory[0];
        sc00_config_command:=1;
        sc00_config_command_req:=1;
      end_if;
      scene_memory_write_req_0:=0;
    end_if;
    
    if scene_memory_write_req_1 then
      if not(sc01_general_error) then
        layout_to_scene(1);
        sc01_rw_status:=2;
        sc01_config_address:=0;
        sc01_config_data_write:=scene_memory[4];
        sc01_config_command:=1;
        sc01_config_command_req:=1;
      end_if;
      scene_memory_write_req_1:=0;
    end_if;
    
    if scene_memory_write_req_2 then
      if not(sc02_general_error) then
        layout_to_scene(2);
        sc02_rw_status:=2;
        sc02_config_address:=0;
        sc02_config_data_write:=scene_memory[8];
        sc02_config_command:=1;
        sc02_config_command_req:=1;
      end_if;
      scene_memory_write_req_2:=0;
    end_if;
    
    if scene_memory_write_req_3 then
      if not(sc03_general_error) then
        layout_to_scene(3);
        sc03_rw_status:=2;
        sc03_config_address:=0;
        sc03_config_data_write:=scene_memory[12];
        sc03_config_command:=1;
        sc03_config_command_req:=1;
      end_if;
      scene_memory_write_req_3:=0;
    end_if;
    
    // reading/writing scene memory
    
    if sc00_config_ack==1 then
      if sc00_config_command==0 then // read
        scene_memory[sc00_config_address+28*(sc00_config_address/4)]:=sc00_config_data_read;
      end_if;
      sc00_config_address:=sc00_config_address+1;
      if sc00_config_address<280 then
        if sc00_config_command=1 then // write
          sc00_config_data_write:=scene_memory[sc00_config_address+28*(sc00_config_address/4)];
        end_if;
        sc00_config_command_req:=1;
      else
        scene_to_layout(0);
        sc00_rw_status:=0;
      end_if;
      sc00_config_ack:=0;
    end_if;
    
    if sc01_config_ack==1 then
      if sc01_config_command==0 then // read
        scene_memory[sc01_config_address+28*(sc01_config_address/4)+4]:=sc01_config_data_read;
      end_if;
      sc01_config_address:=sc01_config_address+1;
      if sc01_config_address<280 then
        if sc01_config_command=1 then // write
          sc01_config_data_write:=scene_memory[sc01_config_address+28*(sc01_config_address/4)+4];
        end_if;
        sc01_config_command_req:=1;
      else
        scene_to_layout(1);
        sc01_rw_status:=0;
      end_if;
      sc01_config_ack:=0;
    end_if;
    
    if sc02_config_ack==1 then
      if sc02_config_command==0 then // read
        scene_memory[sc02_config_address+28*(sc02_config_address/4)+8]:=sc02_config_data_read;
      end_if;
      sc02_config_address:=sc02_config_address+1;
      if sc02_config_address<280 then
        if sc02_config_command=1 then // write
          sc02_config_data_write:=scene_memory[sc02_config_address+28*(sc02_config_address/4)+8];
        end_if;
        sc02_config_command_req:=1;
      else
        scene_to_layout(2);
        sc02_rw_status:=0;
      end_if;
      sc02_config_ack:=0;
    end_if;
    
    if sc03_config_ack==1 then
      if sc03_config_command==0 then // read
        scene_memory[sc03_config_address+28*(sc03_config_address/4)+12]:=sc03_config_data_read;
      end_if;
      sc03_config_address:=sc03_config_address+1;
      if sc03_config_address<280 then
        if sc03_config_command=1 then // write
          sc03_config_data_write:=scene_memory[sc03_config_address+28*(sc03_config_address/4)+12];
        end_if;
        sc03_config_command_req:=1;
      else
        scene_to_layout(3);
        sc03_rw_status:=0;
      end_if;
      sc03_config_ack:=0;
    end_if;
    
    // helper for test output
    
    if test_output_toggle_req then
      global_toggle_request:=test_output_number;
      test_output_toggle_req:=0;
    end_if;
    
    // helper for test scene
    
    if test_scene_req then
      global_scene_request:=test_scene_number;
      test_scene_req:=0;
    end_if;
    
    // scene request from thermostat
    
    if th00_scene_request>=0 then
      if th00_scene_request<=31 then global_scene_request:=th00_scene_request; else global_memory_request:=th00_scene_request-32; end_if;
      th00_scene_request:=-1;
    end_if;
    
    if th01_scene_request>=0 then
      if th01_scene_request<=31 then global_scene_request:=th01_scene_request; else global_memory_request:=th01_scene_request-32; end_if;
      th01_scene_request:=-1;
    end_if;
    
    if th02_scene_request>=0 then
      if th02_scene_request<=31 then global_scene_request:=th02_scene_request; else global_memory_request:=th02_scene_request-32; end_if;
      th02_scene_request:=-1;
    end_if;
    
    if th03_scene_request>=0 then
      if th03_scene_request<=31 then global_scene_request:=th03_scene_request; else global_memory_request:=th03_scene_request-32; end_if;
      th03_scene_request:=-1;
    end_if;
    
    if th04_scene_request>=0 then
      if th04_scene_request<=31 then global_scene_request:=th04_scene_request; else global_memory_request:=th04_scene_request-32; end_if;
      th04_scene_request:=-1;
    end_if;
    
  end;
  function remote_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    i: int;
  var_end;

  begin
    
    // copy received code into a single variable
    
    if sc00_ir_command<>0 then
      if sc00_ir_enable then
        ir_command:=sc00_ir_command;
      end_if;
      sc00_ir_command:=0;
    end_if;
    
    if sc01_ir_command<>0 then
      if sc01_ir_enable then
        ir_command:=sc01_ir_command;
      end_if;
      sc01_ir_command:=0;
    end_if;
    
    if sc02_ir_command<>0 then
      if sc02_ir_enable then
        ir_command:=sc02_ir_command;
      end_if;
      sc02_ir_command:=0;
    end_if;
    
    if sc03_ir_command<>0 then
      if sc03_ir_enable then
        ir_command:=sc03_ir_command;
      end_if;
      sc03_ir_command:=0;
    end_if;
    
    if th00_ir_command<>0 then
      if th00_ir_enable then
        ir_command:=th00_ir_command;
      end_if;
      th00_ir_command:=0;
    end_if;
    
    if th01_ir_command<>0 then
      if th01_ir_enable then
        ir_command:=th01_ir_command;
      end_if;
      th01_ir_command:=0;
    end_if;
    
    if th02_ir_command<>0 then
      if th02_ir_enable then
        ir_command:=th02_ir_command;
      end_if;
      th02_ir_command:=0;
    end_if;
    
    if th03_ir_command<>0 then
      if th03_ir_enable then
        ir_command:=th03_ir_command;
      end_if;
      th03_ir_command:=0;
    end_if;
    
    if th04_ir_command<>0 then
      if th04_ir_enable then
        ir_command:=th04_ir_command;
      end_if;
      th04_ir_command:=0;
    end_if;
    
    // execute IR command
    
    if ir_command<>0 then
      if ir_custom_enable then
        // custom code
        for i:=0 to 31 do
          if ir_command==ir_custom_array[i] then
            global_scene_request:=i;
            i:=31; // break
          end_if;
        end_for;
      else
        // predefined code
        if ir_command>=1152 and ir_command<1184 then
          global_scene_request:=ir_command-1152;
        end_if;
      end_if;
      ir_command_copy:=ir_command; // save a copy for learning
      ir_command:=0; // command consumed
    end_if;
    
    // memorize IR command
    
    if first_scan then
      ir_memory_req:=-1;
    end_if;
    
    if ir_memory_req<>-1 then
      if ir_memory_req>=0 and ir_memory_req<=31 then
        ir_custom_array[ir_memory_req]:=ir_command_copy;
        ir_command_copy:=0; // command consumed
      end_if;
      ir_memory_req:=-1; // request consumed
    end_if;
    
    // erase whole ir memory
    
    if ir_custom_reset_req then
      for i:=0 to 31 do
        ir_custom_array[i]:=0;
      end_for;
      ir_custom_reset_req:=0;
    end_if;
    
  end;
  function ready_light:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var static
    room_number: int;
    fp_clock_1s: bool;
  var_end;

  var constant
    PIRTIME = 5; // Sensor internal timer, from last detection to output off [s].
    FOREVER = 14400; // Timeout for occupied room, 4 hours [s].
  var_end;

  var
    pir_sensor: bool;
    fp_pir_sensor: bool;
    fn_pir_sensor: bool;
    door_open: bool;
    output_state: bool;
    fp_output_state: bool;
    fn_output_state: bool;
    output_timer: int;
    state_machine: int;
    short_timeout: int;
    long_timeout: int;
  var_end;

  begin
    
    // input multiplexer
    
    room_number:=(room_number+1)%4; // next room
    if room_number==0 then fp_clock_1s:=fp(clock_1s); end_if; // valid for all four rooms
    
    pir_sensor:=read_input(ready_light_pir_position[room_number]);
    fp_pir_sensor:=pir_sensor and not(ready_light_pir_sensor[room_number]);
    fn_pir_sensor:=not(pir_sensor) and ready_light_pir_sensor[room_number];
    door_open:=not(read_input(ready_light_reed_position[room_number]));
    output_state:=read_output(ready_light_output_position[room_number])<>0;
    fp_output_state:=output_state and not(ready_light_output_state[room_number]);
    fn_output_state:=not(output_state) and ready_light_output_state[room_number];
    output_timer:=ready_light_timer[room_number];
    state_machine:=ready_light_state[room_number];
    short_timeout:=ready_light_short_timeout[room_number];
    long_timeout:=ready_light_long_timeout[room_number];
    
    // ready light disabled
    
    if not(ready_light_enable[room_number]) or (ready_light_low_light_only[room_number] and not(low_light_indicator)) then
      pir_sensor:=0;
      fp_pir_sensor:=0;
      fn_pir_sensor:=0;
      door_open:=0;
      output_timer:=0;
      state_machine:=0; // empty
    end_if;
    
    // ready light state machine
    
    case state_machine of
    
      0: // state == empty, door is closed and nobody is inside
    
      // door opened
      if door_open then
        output_state:=1;
        output_timer:=long_timeout;
        state_machine:=1; // door open
      end_if;
    
      // pir activated
      if fp_pir_sensor then
        output_state:=1;
        output_timer:=FOREVER;
        state_machine:=3; // occupied
      end_if;
    
      1: // state == open, door is open
    
      // pir reactivated
      if fp_pir_sensor and output_timer==0 then
        output_state:=1;
      end_if;
    
      // pir still active
      if pir_sensor then
        output_timer:=long_timeout; // keep timer loaded
      end_if;
    
      // door closed
      if not(door_open) then
        state_machine:=2; // unknown
      end_if;
    
      2: // state == unknown, door is closed, not known if somebody is inside
    
      // pir not active
      if not(pir_sensor) then
        if output_timer>short_timeout then
          output_timer:=short_timeout;
        end_if;
      end_if;
    
      // pir activated or already active longer then sensor internal timer
      if fp_pir_sensor or (pir_sensor and output_timer==long_timeout-PIRTIME) then
        output_timer:=FOREVER;
        state_machine:=3; // populated
      end_if;
    
      // door open
      if door_open then
        output_timer:=long_timeout;
        state_machine:=1; // door open
      end_if;
    
      // timer expired
      if output_timer==0 then
        state_machine:=0; // empty
      end_if;
    
      3: // state == occupied, door is closed and somebody is inside
    
      // pir active
      if pir_sensor then
        output_timer:=FOREVER; // keep timer loaded
      end_if;
    
      // door open
      if door_open then
        output_timer:=long_timeout;
        state_machine:=1; // door open
      end_if;
    
      // timer expired
      if output_timer==0 then
        state_machine:=0; // empty
      end_if;
    
      // illegal state
      else
        output_timer:=0;
        output_state:=0;
        state_machine:=0;
    end_case;
    
    // timer countdown
    
    if fp_clock_1s then
      if output_timer>0 then
        output_timer:=output_timer-1; // countdown [s]
        if output_timer==0 then
          output_state:=0; // turn output off
        end_if;
      end_if;
    end_if;
    
    // output multiplexer
    
    ready_light_pir_sensor[room_number]:=pir_sensor;
    ready_light_door_open[room_number]:=door_open;
    if output_state<>ready_light_output_state[room_number] then
      write_output(ready_light_output_position[room_number],output_state);
      ready_light_output_state[room_number]:=output_state;
    end_if;
    ready_light_timer[room_number]:=output_timer;
    ready_light_state[room_number]:=state_machine;
    
  end;
  function hvac_algo:void; language 'Structured Text';
    function onoff_algo(temperature,setpoint,mode,hysteresis:int; output:bit):bit; language 'Structured Text';
    begin
      
      // on/off regulation algorythm
      
      if mode==1 then // heating
      
        if setpoint==0 then // disabled
          result:=0;
        elsif temperature<setpoint-hysteresis/2 then // turn on
          result:=1;
        elsif temperature>setpoint+hysteresis/2+hysteresis%2 then // turn off
          result:=0;
        else
          result:=output; // retain old state
        end_if;
      
      elsif mode==2 then // cooling
      
        if setpoint==0 then // disabled
          result:=0;
        elsif temperature>setpoint-hysteresis/2 then // turn on
          result:=1;
        elsif temperature<setpoint+hysteresis/2+hysteresis%2 then // turn off
          result:=0;
        else
          result:=output; // retain old state
        end_if;
      
      else // off
        result:=0;
      end_if;
      
    end;
    function fan_bits_to_word:int; language 'Structured Text';
    begin
      
      // fan configuration word
      
      result:=2*hvac_fan_option_b01+4*hvac_fan_option_b02+8*hvac_fan_option_b03+16*hvac_fan_option_b04;
      
    end;
    function word_to_fan_bits(x:int):void; language 'Structured Text';
    begin
      
      hvac_fan_option_b01:=(x and 2)<>0;
      hvac_fan_option_b02:=(x and 4)<>0;
      hvac_fan_option_b03:=(x and 8)<>0;
      hvac_fan_option_b04:=(x and 16)<>0;
      
    end;
  begin
    
    // on/off algo
    
    if fc00_general_error then
      th00_output:=onoff_algo(th00_temperature,th00_setpoint_active,hvac_mode,th00_hysteresis,th00_output);
    else
      fc00_temperature:=th00_temperature;
      fc00_sensor_error:=th00_sensor_error;
      fc00_setpoint_active:=th00_setpoint_active;
      fc00_fan_limit:=th00_fan_limit;
      fc00_mode:=hvac_mode;
      fc00_hysteresis:=th00_hysteresis;
      th00_output:=bit(fc00_valve);
    end_if;
    
    if fc01_general_error then
      th01_output:=onoff_algo(th01_temperature,th01_setpoint_active,hvac_mode,th01_hysteresis,th01_output);
    else
      fc01_temperature:=th01_temperature;
      fc01_sensor_error:=th01_sensor_error;
      fc01_setpoint_active:=th01_setpoint_active;
      fc01_fan_limit:=th01_fan_limit;
      fc01_mode:=hvac_mode;
      fc01_hysteresis:=th01_hysteresis;
      th01_output:=bit(fc01_valve);
    end_if;
    
    if fc02_general_error then
      th02_output:=onoff_algo(th02_temperature,th02_setpoint_active,hvac_mode,th02_hysteresis,th02_output);
    else
      fc02_temperature:=th02_temperature;
      fc02_sensor_error:=th02_sensor_error;
      fc02_setpoint_active:=th02_setpoint_active;
      fc02_fan_limit:=th02_fan_limit;
      fc02_mode:=hvac_mode;
      fc02_hysteresis:=th02_hysteresis;
      th02_output:=bit(fc02_valve);
    end_if;
    
    if fc03_general_error then
      th03_output:=onoff_algo(th03_temperature,th03_setpoint_active,hvac_mode,th03_hysteresis,th03_output);
    else
      fc03_temperature:=th03_temperature;
      fc03_sensor_error:=th03_sensor_error;
      fc03_setpoint_active:=th03_setpoint_active;
      fc03_fan_limit:=th03_fan_limit;
      fc03_mode:=hvac_mode;
      fc03_hysteresis:=th03_hysteresis;
      th03_output:=bit(fc03_valve);
    end_if;
    
    if fc04_general_error then
      th04_output:=onoff_algo(th04_temperature,th04_setpoint_active,hvac_mode,th04_hysteresis,th04_output);
    else
      fc04_temperature:=th04_temperature;
      fc04_sensor_error:=th04_sensor_error;
      fc04_setpoint_active:=th04_setpoint_active;
      fc04_fan_limit:=th04_fan_limit;
      fc04_mode:=hvac_mode;
      fc04_hysteresis:=th04_hysteresis;
      th04_output:=bit(fc04_valve);
    end_if;
    
    // radiator output mux
    
    cybro_qx00:=th00_output;
    cybro_qx01:=th01_output;
    cybro_qx02:=th02_output;
    cybro_qx03:=th03_output;
    cybro_qx04:=th04_output;
    
    // request for hot/cold water
    
    energy_demand:=(th00_output and th00_demand_enable) or (th01_output and th01_demand_enable) or (th02_output and th02_demand_enable) or (th03_output and th03_demand_enable) or (th04_output and th04_demand_enable);
    
    // boiler/chiller on-delay timer
    
    if energy_demand then
      if energy_delay_counter>=energy_delay then
        energy_output:=1;
        energy_delay_percents:=100;
      else
        energy_delay_counter:=energy_delay_counter+fp(clock_1s);
        energy_delay_percents:=int(100*long(energy_delay_counter)/energy_delay);
      end_if;
    else
      energy_output:=0;
      energy_delay_counter:=0;
      energy_delay_percents:=0;
    end_if;
    
    // boiler/chiller output mux
    
    if hvac_mode==1 then // heating
      boiler_output:=energy_output;
      chiller_output:=0;
    elsif hvac_mode==2 then // cooling
      boiler_output:=0;
      chiller_output:=energy_output;
    else // off
      boiler_output:=0;
      chiller_output:=0;
    end_if;
    
    cybro_qx06:=boiler_output;
    cybro_qx07:=chiller_output;
    
    // write configuration from panel to thermostat
    
    if th00_config1_req then
      th00_temperature_source:=hvac_temperature_source;
      th00_fan_options:=fan_bits_to_word();
      th00_display_mode:=hvac_display_mode;
      th00_rw_indicator:=2;
      th00_selected:=1;
      th_options_timer:=25;
    end_if;
    
    if th01_config1_req then
      th01_temperature_source:=hvac_temperature_source;
      th01_fan_options:=fan_bits_to_word();
      th01_display_mode:=hvac_display_mode;
      th01_rw_indicator:=2;
      th01_selected:=1;
      th_options_timer:=25;
    end_if;
    
    if th02_config1_req then
      th02_temperature_source:=hvac_temperature_source;
      th02_fan_options:=fan_bits_to_word();
      th02_display_mode:=hvac_display_mode;
      th02_rw_indicator:=2;
      th02_selected:=1;
      th_options_timer:=25;
    end_if;
    
    if th03_config1_req then
      th03_temperature_source:=hvac_temperature_source;
      th03_fan_options:=fan_bits_to_word();
      th03_display_mode:=hvac_display_mode;
      th03_rw_indicator:=2;
      th03_selected:=1;
      th_options_timer:=25;
    end_if;
    
    if th04_config1_req then
      th04_temperature_source:=hvac_temperature_source;
      th04_fan_options:=fan_bits_to_word();
      th04_display_mode:=hvac_display_mode;
      th04_rw_indicator:=2;
      th04_selected:=1;
      th_options_timer:=25;
    end_if;
    
    // read configuration from thermostat to panel
    
    if th00_options_back_req then
      hvac_temperature_source:=th00_temperature_source;
      word_to_fan_bits(th00_fan_options);
      hvac_display_mode:=th00_display_mode;
      th00_selected:=1;
      th00_rw_indicator:=1;
      th_options_timer:=10;
      th00_options_back_req:=0;
    end_if;
    
    if th01_options_back_req then
      hvac_temperature_source:=th01_temperature_source;
      word_to_fan_bits(th01_fan_options);
      hvac_display_mode:=th01_display_mode;
      th01_selected:=1;
      th01_rw_indicator:=1;
      th_options_timer:=10;
      th01_options_back_req:=0;
    end_if;
    
    if th02_options_back_req then
      hvac_temperature_source:=th02_temperature_source;
      word_to_fan_bits(th02_fan_options);
      hvac_display_mode:=th02_display_mode;
      th02_selected:=1;
      th02_rw_indicator:=1;
      th_options_timer:=10;
      th02_options_back_req:=0;
    end_if;
    
    if th03_options_back_req then
      hvac_temperature_source:=th03_temperature_source;
      word_to_fan_bits(th03_fan_options);
      hvac_display_mode:=th03_display_mode;
      th03_selected:=1;
      th03_rw_indicator:=1;
      th_options_timer:=10;
      th03_options_back_req:=0;
    end_if;
    
    if th04_options_back_req then
      hvac_temperature_source:=th04_temperature_source;
      word_to_fan_bits(th04_fan_options);
      hvac_display_mode:=th04_display_mode;
      th04_selected:=1;
      th04_rw_indicator:=1;
      th_options_timer:=10;
      th04_options_back_req:=0;
    end_if;
    
    // read/write indicator
    
    if th_options_timer>0 then
      if fp(clock_100ms) then
        th_options_timer:=th_options_timer-1;
        if th_options_timer==0 then
          th00_rw_indicator:=0;
          th01_rw_indicator:=0;
          th02_rw_indicator:=0;
          th03_rw_indicator:=0;
          th04_rw_indicator:=0;
          th00_selected:=0;
          th01_selected:=0;
          th02_selected:=0;
          th03_selected:=0;
          th04_selected:=0;
        end_if;
      end_if;
    end_if;
    
    // temperature measurement
    
    if outdoor_temperature_enable then
      case outdoor_temperature_source of
        0: outdoor_temperature:=th00_temperature_1;
        1: outdoor_temperature:=th01_temperature_1;
        2: outdoor_temperature:=th02_temperature_1;
        3: outdoor_temperature:=th03_temperature_1;
        4: outdoor_temperature:=th04_temperature_1;
      end_case;
    else
      outdoor_temperature:=0;
    end_if;
    
    if wall_temperature_enable then
      case wall_temperature_source of
        0: wall_temperature:=th00_temperature_1;
        1: wall_temperature:=th01_temperature_1;
        2: wall_temperature:=th02_temperature_1;
        3: wall_temperature:=th03_temperature_1;
        4: wall_temperature:=th04_temperature_1;
      end_case;
    else
      wall_temperature:=0;
    end_if;
    
    if water_temperature_enable then
      case water_temperature_source of
        0: water_temperature:=th00_temperature_1;
        1: water_temperature:=th01_temperature_1;
        2: water_temperature:=th02_temperature_1;
        3: water_temperature:=th03_temperature_1;
        4: water_temperature:=th04_temperature_1;
      end_case;
    else
      water_temperature:=0;
    end_if;
    
    if auxilary_temperature_enable then
      case auxilary_temperature_source of
        0: auxilary_temperature:=th00_temperature_1;
        1: auxilary_temperature:=th01_temperature_1;
        2: auxilary_temperature:=th02_temperature_1;
        3: auxilary_temperature:=th03_temperature_1;
        4: auxilary_temperature:=th04_temperature_1;
      end_case;
    else
      auxilary_temperature:=0;
    end_if;
    
  end;
  function timetable_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    i0: int;
    i1: int;
  var_end;

  begin
    
    // execute once per half hour
    
    if fp((rtc_min==0) or (rtc_min==30)) then
    
      i0:=48*((rtc_weekday+6)%7)+2*rtc_hour+(rtc_min>=30); // current timetable index
      i1:=(i0+335)%336; // previous timetable index
    
      // timetable 0
    
      if timetable_0_array[i0]==1 and timetable_0_array[i1]==0 then
        /* turn on */
        if timetable_0_th00_enable then th00_active:=1; end_if;
        if timetable_0_th01_enable then th01_active:=1; end_if;
        if timetable_0_th02_enable then th02_active:=1; end_if;
        if timetable_0_th03_enable then th03_active:=1; end_if;
        if timetable_0_th04_enable then th04_active:=1; end_if;
        if timetable_0_output_enable then write_output(timetable_0_output_number,100); end_if;
        if timetable_0_scene_enable then global_scene_request:=timetable_0_scene_on_number; end_if;
    
      elsif timetable_0_array[i0]==0 and timetable_0_array[i1]==1 then
        /* turn off */
        if timetable_0_th00_enable then th00_active:=0; end_if;
        if timetable_0_th01_enable then th01_active:=0; end_if;
        if timetable_0_th02_enable then th02_active:=0; end_if;
        if timetable_0_th03_enable then th03_active:=0; end_if;
        if timetable_0_th04_enable then th04_active:=0; end_if;
        if timetable_0_output_enable then write_output(timetable_0_output_number,0); end_if;
        if timetable_0_scene_enable then global_scene_request:=timetable_0_scene_off_number; end_if;
    
      end_if;
    
      // timetable 1
    
      if timetable_1_array[i0]==1 and timetable_1_array[i1]==0 then
        /* turn on */
        if timetable_1_th00_enable then th00_active:=1; end_if;
        if timetable_1_th01_enable then th01_active:=1; end_if;
        if timetable_1_th02_enable then th02_active:=1; end_if;
        if timetable_1_th03_enable then th03_active:=1; end_if;
        if timetable_1_th04_enable then th04_active:=1; end_if;
        if timetable_1_output_enable then write_output(timetable_1_output_number,100); end_if;
        if timetable_1_scene_enable then global_scene_request:=timetable_1_scene_on_number; end_if;
    
      elsif timetable_1_array[i0]==0 and timetable_1_array[i1]==1 then
        /* turn off */
        if timetable_1_th00_enable then th00_active:=0; end_if;
        if timetable_1_th01_enable then th01_active:=0; end_if;
        if timetable_1_th02_enable then th02_active:=0; end_if;
        if timetable_1_th03_enable then th03_active:=0; end_if;
        if timetable_1_th04_enable then th04_active:=0; end_if;
        if timetable_1_output_enable then write_output(timetable_1_output_number,0); end_if;
        if timetable_1_scene_enable then global_scene_request:=timetable_1_scene_off_number; end_if;
    
      end_if;
    
      // timetable 2
    
      if timetable_2_array[i0]==1 and timetable_2_array[i1]==0 then
        /* turn on */
        if timetable_2_th00_enable then th00_active:=1; end_if;
        if timetable_2_th01_enable then th01_active:=1; end_if;
        if timetable_2_th02_enable then th02_active:=1; end_if;
        if timetable_2_th03_enable then th03_active:=1; end_if;
        if timetable_2_th04_enable then th04_active:=1; end_if;
        if timetable_2_output_enable then write_output(timetable_2_output_number,100); end_if;
        if timetable_2_scene_enable then global_scene_request:=timetable_2_scene_on_number; end_if;
    
      elsif timetable_2_array[i0]==0 and timetable_2_array[i1]==1 then
        /* turn off */
        if timetable_2_th00_enable then th00_active:=0; end_if;
        if timetable_2_th01_enable then th01_active:=0; end_if;
        if timetable_2_th02_enable then th02_active:=0; end_if;
        if timetable_2_th03_enable then th03_active:=0; end_if;
        if timetable_2_th04_enable then th04_active:=0; end_if;
        if timetable_2_output_enable then write_output(timetable_2_output_number,0); end_if;
        if timetable_2_scene_enable then global_scene_request:=timetable_2_scene_off_number; end_if;
    
      end_if;
    
    end_if;
    
  end;
  function low_light_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var static
    hi: ARRAY[0..3] OF int;
  var_end;

  var
    eot: int;
    di: int;
    df: int;
    hat: int;
  var_end;

  begin
    
    // calculate daylight status (light or dark) based on calculated
    // sunrise and sunset times with optional user offset
    // calculation is based on latitude, longitude, time zone and RTC
    // latitude is valid in range -65 to +65 (positive=north, negative=south)
    // longitude is valid in range -180 to +180 (positive=east, negative=west)
    // precision is +/-15 minutes at the north and south extremes, +/-5 minutes otherwise
    
    // calculate equation of time
    
    di:=day_of_year/28;
    df:=day_of_year mod 28;
    case di of
     0: eot:=(-11*df)/28-3;
     1: eot:=df/28-14;
     2: eot:=(7*df)/28-13;
     3: eot:=(8*df)/28-6;
     4: eot:=(2*df)/28+2;
     5: eot:=(-5*df)/28+4;
     6: eot:=(-5*df)/28-1;
     7: eot:=-6;
     8: eot:=(9*df)/28-6;
     9: eot:=(10*df)/28+3;
     10:eot:=(4*df)/28+13;
     11:eot:=(-6*df)/28+17;
     12:eot:=(-14*df)/28+11;
     13:eot:=(-11*df)/28-3;
    else
      eot:=0;
    end_case;
    
    // calculate hour angle
    
    if (latitude>=0) and (latitude<45) then
      hi[0]:=(-102*latitude)/45+3;
      hi[1]:=(-91*latitude)/45+3;
      hi[2]:=(96*latitude)/45+3;
      hi[3]:=(107*latitude)/45+3;
    elsif (latitude>=45) and (latitude<60) then
      hi[0]:=(-86*(latitude-45))/15-99;
      hi[1]:=(-75*(latitude-45))/15-88;
      hi[2]:=(81*(latitude-45))/15+99;
      hi[3]:=(100*(latitude-45))/15+110;
    elsif latitude>=60 then
      hi[0]:=(-75*(latitude-60))/5-185;
      hi[1]:=(-47*(latitude-60))/5-163;
      hi[2]:=(60*(latitude-60))/5+180;
      hi[3]:=(95*(latitude-60))/5+210;
    elsif (latitude>=-45) and (latitude<0) then
      hi[0]:=(-107*(latitude+45))/45+110;
      hi[1]:=(-95*(latitude+45))/45+98;
      hi[2]:=(91*(latitude+45))/45-88;
      hi[3]:=(102*(latitude+45))/45-99;
    elsif (latitude>=-60) and (latitude<-45) then
      hi[0]:=(-100*(latitude+60))/15+210;
      hi[1]:=(-82*(latitude+60))/15+180;
      hi[2]:=(74*(latitude+60))/15-162;
      hi[3]:=(86*(latitude+60))/15-185;
    else // latitude<-60
      hi[0]:=(-97*(latitude+65))/5+307;
      hi[1]:=(-56*(latitude+65))/5+236;
      hi[2]:=(53*(latitude+65))/5-215;
      hi[3]:=(70*(latitude+65))/5-255;
    end_if;
    
    if (day_of_year<14) or (day_of_year>=354) then
      hat:=(hi[1]-hi[0])*((day_of_year+12) mod 366)/26+hi[0];
    elsif (day_of_year>=12) and (day_of_year<146) then
      hat:=int((hi[2]-hi[1])*(long(day_of_year)-14)/132)+hi[1];
    elsif (day_of_year>=146) and (day_of_year<172) then
      hat:=(hi[3]-hi[2])*(day_of_year-146)/26+hi[2];
    elsif (day_of_year>=172) and (day_of_year<198) then
      hat:=(hi[2]-hi[3])*(day_of_year-172)/26+hi[3];
    elsif (day_of_year>=198) and (day_of_year<328) then
      hat:=int(((hi[1]-hi[2])*(long(day_of_year)-198))/130)+hi[2];
    elsif (day_of_year>=328) and (day_of_year<354) then
      hat:=(hi[0]-hi[1])*(day_of_year-328)/26+hi[1];
    end_if;
    
    // calculate sunrise and sunset time, corected by local offset [minutes]
    
    sunrise:=360+time_zone*60-(longitude*4+eot+hat)+local_offset;
    sunset:=1080+time_zone*60-(longitude*4+eot-hat)-local_offset;
    
    sunrise_hour:=sunrise/60; // used to show on mini scada
    sunrise_min:=sunrise%60;
    sunset_hour:=sunset/60;
    sunset_min:=sunset%60;
    
    // set low light indicator
    
    low_light_indicator:=(minute_of_day<sunrise) or (minute_of_day>sunset) or ((cybro_iw00<light_sensor_threshold) and light_sensor_enable);
    
  end;
  function presence_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var static
    longpress_counter: int;
  var_end;

  begin
    
    // smartphone presence timer
    
    if smartphone_home_event or smartphone_presence_signal then
      presence_counter:=presence_timeout; // timer reload
      if presence_phone_enable then
        presence_indicator:=1;
      end_if;
      smartphone_home_event:=0;
      smartphone_presence_signal:=0;
    end_if;
    
    if presence_counter>0 then
      if fp(clock_1s) then
        presence_counter:=presence_counter-1;
        presence_percent:=int(100*long(presence_counter)/presence_timeout);
        if presence_counter==0 and presence_phone_enable then
          presence_indicator:=0;
        end_if;
      end_if;
    end_if;
    
    // external on/off
    
    if presence_on_enable then
      if fp(read_input(presence_on_position)) then
        presence_indicator:=1;
      end_if;
    end_if;
    
    if presence_off_enable then
      if fp(read_input(presence_off_position)) then
        presence_indicator:=0;
      end_if;
    end_if;
    
    if presence_onoff_enable then
      if fp(read_input(presence_onoff_position)) then
        presence_indicator:=1;
      elsif fn(read_input(presence_onoff_position)) then
        presence_indicator:=0;
      end_if;
    end_if;
    
    // button on/off
    
    if presence_button_enable then
      if not(presence_button_longpress) then
        // shortpress
        if fp(read_input(presence_button_position)) then
          presence_indicator:=not(presence_indicator);
        end_if;
      else
        // longpress timer
        if read_input(presence_button_position) then
          longpress_counter:=longpress_counter+fp(clock_100ms);
        else
          longpress_counter:=0;
        end_if;
        // longpress detection
        if fp(longpress_counter==25) then // longpress time [*100ms]
          presence_indicator:=not(presence_indicator);
        end_if;
      end_if;
    end_if;
    
    // state indicator
    
    if presence_indicator_enable then
      if fp(presence_indicator) then
        if presence_indicator_blink then
          global_blink_request:=presence_indicator_position;
        else
          write_output(presence_indicator_position,1);
        end_if;
      elsif fn(presence_indicator) then
        if presence_indicator_blink then
          global_blink_request:=presence_indicator_position;
        else
          write_output(presence_indicator_position,0);
        end_if;
      end_if;
    end_if;
    
  end;
  function automation_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var static
    next_minute: int; // Random lights, minutes to next event.
    scene_index: int; // Random lights, index of currently selected scene.
    th00_setpoint_old: int;
    th01_setpoint_old: int;
    th02_setpoint_old: int;
    th03_setpoint_old: int;
    th04_setpoint_old: int;
  var_end;

  var constant
    SPTIMEOUT = 60; // Timeout for defult setpoint [min].
  var_end;

  var
    offset: int; // Bio offset, temporary setpoint offset.
  var_end;

    function rnd(range:int):int; language 'Structured Text';
    // AllocGroupList="User Variables"
    var static
      seed: long; // pseudo-random seed
    var_end;

    begin
      
      // function rnd(range:int):int;
      //
      // simple pseudo-random generator
      //
      // output is 15-bit positive integer from 0 to range-1
      // new value is evaluated with each call
      // algorithm is linear congruential generator, Xn+1:=(a*Xn+c) mod m
      // constants are taken from "Numerical Recipes": m=2^32, a=1664525, c=1013904223
      
      if seed==0 then
        seed:=rtc_hour*rtc_min*rtc_sec*get_serial(); // initial seed
      end_if;
      
      seed:=1664525*seed+1013904223;
      
      result:=(int(seed/8) and 16#7FFF)%range;
      
    end;
  begin
    
    // coming home
    
    if fp(presence_indicator) or coming_home_test_req then
      coming_home_test_req:=0;
      if coming_home_enable then
        // activate thermostat
        if coming_home_th00_enable then th00_active:=1; end_if;
        if coming_home_th01_enable then th01_active:=1; end_if;
        if coming_home_th02_enable then th02_active:=1; end_if;
        if coming_home_th03_enable then th03_active:=1; end_if;
        if coming_home_th04_enable then th04_active:=1; end_if;
        // activate scene and lights
        if low_light_indicator or not(coming_home_dark_only) then
          if coming_home_scene_enable then
            global_scene_request:=coming_home_scene_number;
            global_scene_no_inverse:=1;
          end_if;
        end_if;
      end_if;
    end_if;
    
    // leaving home
    
    if fn(presence_indicator) or leaving_home_test_req then
      leaving_home_test_req:=0;
      if leaving_home_enable then
        // deactivate thermostat
        if leaving_home_th00_enable then th00_active:=0; end_if;
        if leaving_home_th01_enable then th01_active:=0; end_if;
        if leaving_home_th02_enable then th02_active:=0; end_if;
        if leaving_home_th03_enable then th03_active:=0; end_if;
        if leaving_home_th04_enable then th04_active:=0; end_if;
        // activate scene and lights
        if low_light_indicator or not(leaving_home_dark_only) then
          if leaving_home_scene_enable then
            global_scene_request:=leaving_home_scene_number;
            global_scene_no_inverse:=1;
          end_if;
        end_if;
      end_if;
    end_if;
    
    // smart lights
    
    if (fp(low_light_indicator) and presence_indicator) or smart_lights_test_req then
      if smart_lights_enable and smart_lights_scene_enable then
        global_scene_request:=smart_lights_scene_on_number; // lights on
        global_scene_no_inverse:=1;
      end_if;
      if smart_lights_enable and smart_lights_dimmer_enable then
        if smart_lights_dimmer_time==0 then
          // set output instantly
          write_output(smart_lights_dimmer_number+40,smart_lights_dimmer_setpoint);
        else
          // start dimming procedure
          smart_lights_active:=1;
          smart_lights_brightness:=read_output(smart_lights_dimmer_number+40);
        end_if;
      end_if;
      smart_lights_test_req:=0;
    elsif fn(low_light_indicator) then
      if smart_lights_enable and smart_lights_scene_enable then
        global_scene_request:=smart_lights_scene_off_number; // lights off
        global_scene_no_inverse:=1;
      end_if;
      if smart_lights_enable and smart_lights_dimmer_enable then
        write_output(smart_lights_dimmer_number+40,0); // dimmer off
      end_if;
    end_if;
    
    if smart_lights_active then
      if smart_lights_brightness<>read_output(smart_lights_dimmer_number+40) or not(smart_lights_enable) or not(smart_lights_dimmer_enable) then
        // changed manually or turned off, stop procedure
        smart_lights_brightness:=0;
        smart_lights_counter:=0;
        smart_lights_active:=0;
      elsif fp(clock_1s) then
        if smart_lights_counter>0 then
          smart_lights_counter:=smart_lights_counter-1;
        end_if;
        if smart_lights_counter==0 then
          // increment brightness by 1
          smart_lights_brightness:=smart_lights_brightness+1;
          write_output(smart_lights_dimmer_number+40,smart_lights_brightness);
          if smart_lights_brightness<smart_lights_dimmer_setpoint then
            smart_lights_counter:=smart_lights_dimmer_time*60/smart_lights_dimmer_setpoint;
          else
            smart_lights_brightness:=0;
            smart_lights_counter:=0;
            smart_lights_active:=0;
          end_if;
        end_if;
      end_if;
    end_if;
    
    // random lights
    
    if low_light_indicator and not(presence_indicator) then
      if random_lights_enable then
        if rtc_min==next_minute or random_lights_test_req then
          next_minute:=(next_minute+15+rnd(45))%60; // next change in 15..59 minutes
          scene_index:=(scene_index+rnd(2)+1)%3; // next scene in one of two remaining
          global_scene_request:=random_lights_scene[scene_index];
          global_scene_no_inverse:=1;
        end_if;
      end_if;
      random_lights_test_req:=0;
    end_if;
    
    // smartphone alarm
    
    if smartphone_alarm_event then
      smartphone_alarm_event:=0; // currently not used
    end_if;
    
    // warm wake up
    
    if smartphone_precede_event then
      if comfort_wake_up_enable then
        // activate thermostat
        if comfort_wake_up_th00_enable then th00_active:=1; end_if;
        if comfort_wake_up_th01_enable then th01_active:=1; end_if;
        if comfort_wake_up_th02_enable then th02_active:=1; end_if;
        if comfort_wake_up_th03_enable then th03_active:=1; end_if;
        if comfort_wake_up_th04_enable then th04_active:=1; end_if;
        // activate scene and lights
        if low_light_indicator or not(comfort_wake_up_dark_only) then
          if comfort_wake_up_scene_enable then
            global_scene_request:=comfort_wake_up_scene_number;
            global_scene_no_inverse:=1;
          end_if;
        end_if;
      end_if;
      if sunny_wake_up_enable then
        // sunny wake up init
        sunny_wake_up_active:=1;
        sunny_wake_up_position:=read_output(sunny_wake_up_blinds_number+56);
      end_if;
      smartphone_precede_event:=0;
    end_if;
    
    // sunny wake up
    
    if sunny_wake_up_active then
      if not(sunny_wake_up_gradually) then
        // move instantly to the position
        write_output(sunny_wake_up_blinds_number+56,sunny_wake_up_setpoint);
        sunny_wake_up_position:=0;
        sunny_wake_up_active:=0;
      elsif fp(clock_10s) then
        if sunny_wake_up_position<>read_output(sunny_wake_up_blinds_number+56) or not(sunny_wake_up_enable) then
          // moved manually or turned off, stop procedure
          sunny_wake_up_position:=0;
          sunny_wake_up_active:=0;
        elsif sunny_wake_up_position<sunny_wake_up_setpoint then
          // move blinds down
          sunny_wake_up_position:=sunny_wake_up_position+1;
          write_output(sunny_wake_up_blinds_number+56,sunny_wake_up_position);
        elsif sunny_wake_up_position>sunny_wake_up_setpoint then
          // move blinds up
          sunny_wake_up_position:=sunny_wake_up_position-1;
          write_output(sunny_wake_up_blinds_number+56,sunny_wake_up_position);
        end_if;
        if sunny_wake_up_position==sunny_wake_up_setpoint then
          // setpoint reached, stop procedure
          sunny_wake_up_position:=0;
          sunny_wake_up_active:=0;
        end_if;
      end_if;
    end_if;
    
    // default setpoint
    
    if default_setpoint_enable and fp(clock_1min) then
    
      // thermostat th00
      if not(default_setpoint_th00_enable) or th00_setpoint==default_setpoint_th00 then
        th00_setpoint_timeout:=0; // stop timer
        th00_setpoint_old:=default_setpoint_th00;
      else
        if th00_setpoint<>th00_setpoint_old then
          th00_setpoint_timeout:=SPTIMEOUT; // start timer
        elsif th00_setpoint_timeout>0 then
          th00_setpoint_timeout:=th00_setpoint_timeout-1;
          if th00_setpoint_timeout==0 then
            th00_setpoint:=default_setpoint_th00; // return to default setpoint
          end_if;
        end_if;
        th00_setpoint_old:=th00_setpoint;
      end_if;
    
      // thermostat th01
      if not(default_setpoint_th01_enable) or th01_setpoint==default_setpoint_th01 then
        th01_setpoint_timeout:=0; // stop timer
        th01_setpoint_old:=default_setpoint_th01;
      else
        if th01_setpoint<>th01_setpoint_old then
          th01_setpoint_timeout:=SPTIMEOUT; // start timer
        elsif th01_setpoint_timeout>0 then
          th01_setpoint_timeout:=th01_setpoint_timeout-1;
          if th01_setpoint_timeout==0 then
            th01_setpoint:=default_setpoint_th01; // return to default setpoint
          end_if;
        end_if;
        th01_setpoint_old:=th01_setpoint;
      end_if;
    
      // thermostat th02
      if not(default_setpoint_th02_enable) or th02_setpoint==default_setpoint_th02 then
        th02_setpoint_timeout:=0; // stop timer
        th02_setpoint_old:=default_setpoint_th02;
      else
        if th02_setpoint<>th02_setpoint_old then
          th02_setpoint_timeout:=SPTIMEOUT; // start timer
        elsif th02_setpoint_timeout>0 then
          th02_setpoint_timeout:=th02_setpoint_timeout-1;
          if th02_setpoint_timeout==0 then
            th02_setpoint:=default_setpoint_th02; // return to default setpoint
          end_if;
        end_if;
        th02_setpoint_old:=th02_setpoint;
      end_if;
    
      // thermostat th03
      if not(default_setpoint_th03_enable) or th03_setpoint==default_setpoint_th03 then
        th03_setpoint_timeout:=0; // stop timer
        th03_setpoint_old:=default_setpoint_th03;
      else
        if th03_setpoint<>th03_setpoint_old then
          th03_setpoint_timeout:=SPTIMEOUT; // start timer
        elsif th03_setpoint_timeout>0 then
          th03_setpoint_timeout:=th03_setpoint_timeout-1;
          if th03_setpoint_timeout==0 then
            th03_setpoint:=default_setpoint_th03; // return to default setpoint
          end_if;
        end_if;
        th03_setpoint_old:=th03_setpoint;
      end_if;
    
      // thermostat th04
      if not(default_setpoint_th04_enable) or th04_setpoint==default_setpoint_th04 then
        th04_setpoint_timeout:=0; // stop timer
        th04_setpoint_old:=default_setpoint_th04;
      else
        if th04_setpoint<>th04_setpoint_old then
          th04_setpoint_timeout:=SPTIMEOUT; // start timer
        elsif th04_setpoint_timeout>0 then
          th04_setpoint_timeout:=th04_setpoint_timeout-1;
          if th04_setpoint_timeout==0 then
            th04_setpoint:=default_setpoint_th04; // return to default setpoint
          end_if;
        end_if;
        th04_setpoint_old:=th04_setpoint;
      end_if;
    
    end_if;
    
    // bio offset
    
    if fp(clock_1min) then
      offset:=0;
      if bio_offset_enable then
        offset:=bio_offset_array[rtc_hour/2];
      end_if;
      th00_setpoint_offset:=offset;
      th01_setpoint_offset:=offset;
      th02_setpoint_offset:=offset;
      th03_setpoint_offset:=offset;
      th04_setpoint_offset:=offset;
    end_if;
    
    // connect charger
    
    if smartphone_charge_on_event then
      // deactivate thermostat
      if connect_charger_th00_enable then th00_active:=0; end_if;
      if connect_charger_th01_enable then th01_active:=0; end_if;
      if connect_charger_th02_enable then th02_active:=0; end_if;
      if connect_charger_th03_enable then th03_active:=0; end_if;
      if connect_charger_th04_enable then th04_active:=0; end_if;
      // activate scene and lights
      if low_light_indicator or not(connect_charger_dark_only) then
        if connect_charger_scene_enable then
          global_scene_request:=connect_charger_scene_number;
          global_scene_no_inverse:=1;
        end_if;
      end_if;
      smartphone_charge_on_event:=0;
    end_if;
    
    // disconnect charger
    
    if smartphone_charge_off_event then
      // deactivate thermostat
      if disconnect_charger_th00_enable then th00_active:=1; end_if;
      if disconnect_charger_th01_enable then th01_active:=1; end_if;
      if disconnect_charger_th02_enable then th02_active:=1; end_if;
      if disconnect_charger_th03_enable then th03_active:=1; end_if;
      if disconnect_charger_th04_enable then th04_active:=1; end_if;
      // activate scene and lights
      if low_light_indicator or not(disconnect_charger_dark_only) then
        if disconnect_charger_scene_enable then
          global_scene_request:=disconnect_charger_scene_number;
          global_scene_no_inverse:=1;
        end_if;
      end_if;
      smartphone_charge_off_event:=0;
    end_if;
    
    // call notification
    
    if smartphone_call_event then
      if call_notification_enable then
        // blink selected light a few times
        global_blink_request:=call_notification_light_number;
      end_if;
      smartphone_call_event:=0;
    end_if;
    
    // text notification
    
    if smartphone_text_event then
      if text_notification_enable then
        // blink selected light a few times
        global_blink_request:=text_notification_light_number;
      end_if;
      smartphone_text_event:=0;
    end_if;
    
  end;
  function alarm_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var static
    index: int; // Current sensor.
    longpress_counter: int;
    alarm_indicator: bool;
    alarm_indicator_old: bool;
  var_end;

  begin
    
    index:=(index+1)%12; // next sensor
    
    // on/off request
    
    if alarm_onoff_req then
      if alarm_state==0 then
        alarm_state:=1; // arming
      else
        alarm_state:=0; // off
      end_if;
      alarm_onoff_req:=0;
    end_if;
    
    // auto arming
    
    if alarm_auto_arming and fn(presence_indicator) then
      if alarm_state==0 then
        alarm_state:=1; // arming
      end_if;
    end_if;
    
    if alarm_auto_arming and fp(presence_indicator) then
      if alarm_state==1 or alarm_state==2 or alarm_state==3 then
        alarm_state:=0; // off
      elsif alarm_state==4 then
        alarm_state:=5; // expired
      end_if;
    end_if;
    
    // code arming/disarming
    
    if alarm_code_request<>0 then
      if alarm_code_request==alarm_code_memory then
        if alarm_state==0 then
          alarm_state:=1; // arming
        else
          alarm_state:=0; // off
        end_if;
      end_if;
      alarm_code_request:=0;
    end_if;
    
    // alarm state indicator
    
    if alarm_indicator_enable then
      if alarm_indicator_blink then
        if fp(alarm_state==0) then
          global_blink_request:=alarm_indicator_position;
        elsif fp(alarm_state<>0) then
          global_blink_request:=alarm_indicator_position;
        end_if;
      else
        if alarm_state==0 then
          alarm_indicator:=0; // off
        elsif alarm_state==2 or alarm_state==3 then
          alarm_indicator:=1;  // armed, activating
        else
          alarm_indicator:=clock_1s; // arming, active, expired
        end_if;
        if alarm_indicator<>alarm_indicator_old then
          write_output(alarm_indicator_position,alarm_indicator);
          alarm_indicator_old:=alarm_indicator;
        end_if;
      end_if;
    end_if;
    
    // transition indicator
    
    
    // --------------------- state machine ---------------------
    
    // alarm state=off
    
    if fp(alarm_state==0) then
      alarm_arming_counter:=0;
      alarm_delay_counter:=0;
      alarm_active_counter:=0;
      write_output(alarm_output_position,0);
    end_if;
    
    // alarm state=arming
    
    if fp(alarm_state==1) then
      alarm_arming_counter:=alarm_arming_time;
      if alarm_arming_counter==0 then
        alarm_state:=2; // armed
      end_if;
    end_if;
    
    if alarm_arming_counter>0 then
      alarm_arming_counter:=alarm_arming_counter-fp(clock_1s);
      if alarm_arming_counter==0 then
        alarm_state:=2; // armed
      end_if;
    end_if;
    
    // alarm state=armed
    
    if alarm_state==2 then
      if alarm_zone_enable[index/3] then
        if alarm_sensor_enable[index] then
          if read_input(alarm_sensor_position[index]) then
            if alarm_sensor_instant[index] then
              alarm_state:=4; // active
            else
              alarm_state:=3; // activating
            end_if;
          end_if;
        end_if;
      end_if;
    end_if;
    
    // alarm state=activating
    
    if fp(alarm_state==3) then
      alarm_delay_counter:=alarm_delay_time;
    end_if;
    
    if alarm_state==3 then
      if alarm_zone_enable[index/3] then
        if alarm_sensor_enable[index] then
          if read_input(alarm_sensor_position[index]) then
            if alarm_sensor_instant[index] then
              alarm_state:=4; // active
            end_if;
          end_if;
        end_if;
      end_if;
    end_if;
    
    if alarm_delay_counter>0 then
      alarm_delay_counter:=alarm_delay_counter-fp(clock_1s);
      if alarm_delay_counter==0 then
        alarm_state:=4; // active
      end_if;
    end_if;
    
    // alarm state=active
    
    if fp(alarm_state==4) then
      alarm_active_counter:=alarm_active_time;
      write_output(alarm_output_position,1);
      if alarm_scene_enable then
        global_scene_request:=alarm_scene_number;
        global_scene_no_inverse:=1;
      end_if;
    end_if;
    
    if alarm_active_counter>0 then
      alarm_active_counter:=alarm_active_counter-fp(clock_1s);
      if alarm_active_counter==0 then
        alarm_state:=5; // expired
        write_output(alarm_output_position,0);
      end_if;
    end_if;
    
    // alarm state=expired
    
  end;
  function energy_algo:void; language 'Structured Text';
  // AllocGroupList="Energy", "User Variables"
  var static
    modbus_step: int; // Modbus state machine. {AllocGroup="Energy"}
    modbus_para: int; // Current parameter: 0-voltage, 1-power, 2-energy. {AllocGroup="Energy"}
    hour_index: int; // Circular-running index, one array element per scan, 23 to 0, idle at -1.
    day_index: int; // Circular-running index, one array element per scan, 29 to 0, idle at -1.
    output_index: int; // Circular-running index, one output per scan, 55 to 0, idle at -1.
  var_end;

  var
    output_state: int; // Temporary output state, 0..1 or 0..100.
  var_end;

    function rx_to_real:real; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      x: long;
      l: long;
      r: real;
    var_end;

      function push_long(x:long):void; language 'Structured Text';
      // AllocGroupList="User Variables"
      var
        stack: long;
      var_end;

      begin
        
        stack := x;
        
      end;
      function pop_real:real; language 'Structured Text';
      // AllocGroupList="User Variables"
      var
        stack: real;
      var_end;

      begin
        
        result := stack;
        
      end;
      function pop_long:long; language 'Structured Text';
      // AllocGroupList="User Variables"
      var
        stack: long;
      var_end;

      begin
        
        result := stack;
        
      end;
    begin
      
      // read rx buffer 3..6, convert to real and return
      
      x:=16#1000000*word(rx_bufrd(3))+16#10000*word(rx_bufrd(4))+16#100*word(rx_bufrd(5))+word(rx_bufrd(6));
      l:=0;
      
      while l<>x do
        push_long(x); // write long to stack
        r:=pop_real(); // read real from stack
        l:=pop_long(); // read long from stack
      end_while; // repeat if corrupted
      
      result:=r;
      
    end;
  begin
    
    // Eastron power meter 2400bps 8n1
    
    if modbus_step==0 then
      // send modbus request
      com_select(2); // select COM2
      case modbus_para of
        0: dprns(0,0,0,'\01\04\00\0C\00\02\B1\C8'); // power [W]
        1: dprns(0,0,0,'\01\04\00\00\00\02\71\CB'); // voltage [V]
        2: dprns(0,0,0,'\01\04\00\48\00\02\F1\DD'); // energy [kWh]
      end_case;
      tx_start(8);
      modbus_step:=modbus_step+1;
    elsif modbus_step==1 and not(tx_active()) then
      // when transmit is finished, start receive
      rx_start(1,0,0,460,460); // cycle time is determined with timeout
      modbus_step:=modbus_step+1;
    elsif modbus_step==2 and not(rx_active()) then
      // receive finished
      if rx_count()==9 and rx_bufrd(1)==4 and rx_bufrd(2)==4 then
        // received message ok
        case modbus_para of
          0: power_meter_power:=  int(rx_to_real()); // power [W]
          1: power_meter_voltage:=int(rx_to_real()); // voltage [V]
          2: power_meter_energy:= int(rx_to_real()); // energy [kWh]
        end_case;
        power_meter_error:=0;
      else
        // receive error
        power_meter_voltage:=0;
        power_meter_power:=0;
        power_meter_error:=1;
      end_if;
      modbus_para:=(modbus_para+1)%3;
      modbus_step:=0;
    end_if;
    
    // relative power meter
    
    if power_meter_reset_req then
      power_meter_reference:=power_meter_power;
      power_meter_reset_req:=0;
    end_if;
    
    power_meter_relative:=power_meter_power-power_meter_reference;
    
    // energy consumption by hour
    
    if energy_sample_last_hour==0 then
      if power_meter_energy<>0 then
        energy_sample_last_hour:=power_meter_energy; // initialize with the first valid reading
      end_if;
    end_if;
    
    if fp(rtc_min+rtc_sec==0) then
      hour_index:=23; // one hour passed, shift array left
    end_if;
    
    if hour_index>0 then
      energy_consumption_by_hour[hour_index]:=energy_consumption_by_hour[hour_index-1];
      hour_index:=hour_index-1;
    elsif hour_index==0 then
      energy_consumption_by_hour[0]:=int(power_meter_energy-energy_sample_last_hour);
      energy_sample_last_hour:=power_meter_energy;
      hour_index:=-1;
    end_if;
    
    // energy consumption by day
    
    if energy_sample_last_day==0 then
      if power_meter_energy<>0 then
        energy_sample_last_day:=power_meter_energy; // initialize with the first valid reading
      end_if;
    end_if;
    
    if fp(rtc_hour+rtc_min+rtc_sec==0) then
      day_index:=29; // one day passed, shift array left
    end_if;
    
    if day_index>0 then
      energy_consumption_by_day[day_index]:=energy_consumption_by_day[day_index-1];
      day_index:=day_index-1;
    elsif day_index==0 then
      energy_consumption_by_day[0]:=int(power_meter_energy-energy_sample_last_day);
      energy_sample_last_day:=power_meter_energy;
      day_index:=-1;
    end_if;
    
    // energy consumption per output
    
    if fp(clock_1s) then
      output_index:=55; // restart calculation once per second
    end_if;
    
    if output_index>=0 then
      output_state:=read_output(output_index);
      if output_state<0 then
        output_state:=0; // in case of general error, set to zero
      end_if;
    
      if output_state>0 and output_state_last[output_index]==0 then
        output_power_count[output_index]:=output_power_count[output_index]+1; // number of power cycles
      end_if;
      output_state_last[output_index]:=output_state;
    
      if output_state>0 then
        output_operating_seconds[output_index]:=output_operating_seconds[output_index]+1;
        if output_operating_seconds[output_index]>=3600 then
          output_operating_hours[output_index]:=output_operating_hours[output_index]+1; // operating hours
          output_operating_seconds[output_index]:=0;
        end_if;
      end_if;
    
      if output_index<=39 then
        output_moment_power[output_index]:=output_nominal_power[output_index]*output_state; // on/off output
      else
        output_moment_power[output_index]:=int((long(output_nominal_power[output_index])*output_state)/100); // dimmer output
      end_if;
    
      output_energy_counter_ws[output_index]:=output_energy_counter_ws[output_index]+output_moment_power[output_index]; // integrate energy in Ws
    
      if output_energy_counter_ws[output_index]>=3600 then
        output_energy_counter_ws[output_index]:=output_energy_counter_ws[output_index]-3600; // 0..3600 Ws
        output_energy_counter_wh[output_index]:=output_energy_counter_wh[output_index]+1; // 0..1000 Wh
        if output_energy_counter_wh[output_index]>=1000 then
          output_energy_total[output_index]:=output_energy_total[output_index]+1; // energy total in kWh
          output_energy_counter_wh[output_index]:=0;
        end_if;
        output_energy_today[output_index]:=output_energy_today[output_index]+1; // energy today in Wh
      end_if;
    
      if minute_of_day==0 then
        output_energy_today[output_index]:=0; // reset once per day
      end_if;
    
      output_index:=output_index-1; // next output
    end_if;
    
    // helper for configuring energy per output
    
    if energy_per_output_req<>0 then
      if energy_per_output_req==1 then
        output_power_count[test_output_number]:=0;
      elsif energy_per_output_req==2 then
        output_operating_hours[test_output_number]:=0;
      elsif energy_per_output_req==3 then
        output_energy_today[test_output_number]:=0;
        output_energy_total[test_output_number]:=0;
      elsif energy_per_output_req==4 then
        output_nominal_power[test_output_number]:=nominal_power_setting;
      end_if;
      energy_per_output_req:=0;
    end_if;
    
  end;
  function socket_algo:void; language 'Structured Text';
  begin
    
    // initialize
    
    if first_scan then
      socket_scene_request:=-1;
    end_if;
    
    // receive socket
    
    if socket_request and socket_from<>int(get_nad()) then
      if socket_command==1 then
        global_scene_request:=socket_argument_0;
        global_scene_no_inverse:=1;
        global_scene_no_resend:=1;
      end_if;
      socket_request:=0;
    end_if;
    
    // send socket
    
    if socket_scene_request<>-1 then
      if scene_sync_enable[socket_scene_request] then
        socket_request:=1;
        socket_from:=int(get_nad());
        socket_to:=0; // broadcast
        socket_command:=1; // set scene
        socket_argument_0:=socket_scene_request;
      end_if;
      socket_scene_request:=-1;
    end_if;
    
  end;
  function system_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var constant
    PUSHPERIOD = 30; // Period in which push message is sent to server [s].
  var_end;

  var
    ip: long; // Temporary IP address for calculations.
  var_end;

  begin
    
    // program id and version
    
    program_id:=3;
    version_major:=1;
    version_minor:=2;
    version_release:=9; // 9a
    
    // prevent debug state
    
    disconnect_inputs:=0;
    cybro_outputs_off:=0;
    
    // nad and serial number
    
    cybro_nad:=int(get_nad());
    cybro_serial:=int(get_serial());
    
    // ip address
    
    if fp(clock_1s) then
      ip:=get_ip();
      if ip>=0 then
        cybro_ip0:=int(ip/16#1000000);
      else
        ip:=ip+16#80000000;
        cybro_ip0:=int(ip/16#1000000)+128;
      end_if;
      cybro_ip1:=int(long(word(ip/65536))%256);
      cybro_ip2:=int(long(word(ip%65536))/256);
      cybro_ip3:=int(long(word(ip%65536))%256);
    end_if;
    
    // reset counter and retentive memory check
    
    if first_scan then
      reset_counter:=reset_counter+1;
      if retentive_magic<>23061967 then
        retentive_magic:=23061967;
        scene_memory_reset_req:=1;
      end_if;
    end_if;
    
    // once per hour increment cybro uptime and operating hours
    
    if fp(rtc_min==0) then
      cybro_uptime:=cybro_uptime+1;
      operating_hours:=operating_hours+1;
    end_if;
    
    // minute of day (0..1439) and day of year (1..366)
    
    if fp(rtc_sec==0) then
      minute_of_day:=rtc_hour*60+rtc_min;
      day_of_year:=int(275*rtc_month/9)-2*int((rtc_month+9)/12)+rtc_date-30;
    end_if;
    
    // push protocol
    
    if fp(clock_1s) then // generate periodic push message
      if push_enable then
        if push_timer>0 then
          push_timer:=push_timer-1;
        else
          push_req:=1;
          push_timer:=PUSHPERIOD-1; // push period [s]
        end_if;
      else
        push_timer:=0;
        push_status:=0; // disabled
      end_if;
    end_if;
    
    if push_req then // new push cycle
      push_req:=0;
      push_status:=1; // waiting
      push_roundtrip:=0;
      push_message_req:=1; // send push message
      push_req_counter:=push_req_counter+1; // transmitted messages
    end_if;
    
    if push_message_ack then // acknowledge received
      push_message_ack:=0;
      push_status:=2; // ok
      push_ack_counter:=push_ack_counter+1; // received messages
    end_if;
    
    if push_status==1 then // waiting for answer
      push_roundtrip:=push_roundtrip+scan_time; // elapsed milliseconds
      if push_roundtrip>=5000 then // server timeout [ms]
        push_roundtrip:=0;
        push_status:=3; // error
      end_if;
    end_if;
    
    // create authentification code on request
    
    if authentification_req then
      authentification_code:=1664525*scan_frequency*rtc_sec*rtc_min*rtc_hour*get_serial()+1013904223;
      if authentification_code<0 then authentification_code:=-authentification_code; end_if;
      authentification_code:=authentification_code%900000+100000;
      authentification_timer:=600;
      authentification_req:=0;
    end_if;
    
    if authentification_timer<>0 then
      if fp(clock_1s) then
        authentification_timer:=authentification_timer-1;
        if authentification_timer==0 then
          authentification_code:=0;
        end_if;
      end_if;
    end_if;
    
    // autoaddress bargraph
    
    if broadcast_command==1 and broadcast_command_req==1 then
      autoaddress_timer:=900; // manual start
    end_if;
    
    if fp(lc00_autoaddress_active) or fp(ld00_autoaddress_active) or fp(bc00_autoaddress_active) or fp(th00_autoaddress_active) then
      if autoaddress_timer==0 then
        autoaddress_timer:=900; // automatic start
      end_if;
    end_if;
    
    if autoaddress_timer>0 and fp(clock_100ms) then
      autoaddress_timer:=autoaddress_timer-1; // countdown
      autoaddress_percent:=autoaddress_timer/9; // bargraph position
    end_if;
    
    // can error counters
    
    if can_rx_error_counter>can_rx_error_counter_max then
      can_rx_error_counter_max:=can_rx_error_counter;
    end_if;
    
    if can_tx_error_counter>can_tx_error_counter_max then
      can_tx_error_counter_max:=can_tx_error_counter;
    end_if;
    
  end;
  function read_input(i:int):bit; language 'Structured Text';
  begin
    
    // read a single input from light controller (0..39)
    
    case i of
       0: result:=lc00_ix00;
       1: result:=lc00_ix01;
       2: result:=lc00_ix02;
       3: result:=lc00_ix03;
       4: result:=lc00_ix04;
       5: result:=lc00_ix05;
       6: result:=lc00_ix06;
       7: result:=lc00_ix07;
       8: result:=lc00_ix08;
       9: result:=lc00_ix09;
    
      10: result:=lc01_ix00;
      11: result:=lc01_ix01;
      12: result:=lc01_ix02;
      13: result:=lc01_ix03;
      14: result:=lc01_ix04;
      15: result:=lc01_ix05;
      16: result:=lc01_ix06;
      17: result:=lc01_ix07;
      18: result:=lc01_ix08;
      19: result:=lc01_ix09;
    
      20: result:=lc02_ix00;
      21: result:=lc02_ix01;
      22: result:=lc02_ix02;
      23: result:=lc02_ix03;
      24: result:=lc02_ix04;
      25: result:=lc02_ix05;
      26: result:=lc02_ix06;
      27: result:=lc02_ix07;
      28: result:=lc02_ix08;
      29: result:=lc02_ix09;
    
      30: result:=lc03_ix00;
      31: result:=lc03_ix01;
      32: result:=lc03_ix02;
      33: result:=lc03_ix03;
      34: result:=lc03_ix04;
      35: result:=lc03_ix05;
      36: result:=lc03_ix06;
      37: result:=lc03_ix07;
      38: result:=lc03_ix08;
      39: result:=lc03_ix09;
    else
      result:=0;
    end_case;
    
  end;
  function read_input_mode(i:int):int; language 'Structured Text';
  begin
    
    // read input mode from light controller (0..39)
    
    case i of
       0: result:=lc00_input_mode_00;
       1: result:=lc00_input_mode_01;
       2: result:=lc00_input_mode_02;
       3: result:=lc00_input_mode_03;
       4: result:=lc00_input_mode_04;
       5: result:=lc00_input_mode_05;
       6: result:=lc00_input_mode_06;
       7: result:=lc00_input_mode_07;
       8: result:=lc00_input_mode_08;
       9: result:=lc00_input_mode_09;
    
      10: result:=lc01_input_mode_00;
      11: result:=lc01_input_mode_01;
      12: result:=lc01_input_mode_02;
      13: result:=lc01_input_mode_03;
      14: result:=lc01_input_mode_04;
      15: result:=lc01_input_mode_05;
      16: result:=lc01_input_mode_06;
      17: result:=lc01_input_mode_07;
      18: result:=lc01_input_mode_08;
      19: result:=lc01_input_mode_09;
    
      20: result:=lc02_input_mode_00;
      21: result:=lc02_input_mode_01;
      22: result:=lc02_input_mode_02;
      23: result:=lc02_input_mode_03;
      24: result:=lc02_input_mode_04;
      25: result:=lc02_input_mode_05;
      26: result:=lc02_input_mode_06;
      27: result:=lc02_input_mode_07;
      28: result:=lc02_input_mode_08;
      29: result:=lc02_input_mode_09;
    
      30: result:=lc03_input_mode_00;
      31: result:=lc03_input_mode_01;
      32: result:=lc03_input_mode_02;
      33: result:=lc03_input_mode_03;
      34: result:=lc03_input_mode_04;
      35: result:=lc03_input_mode_05;
      36: result:=lc03_input_mode_06;
      37: result:=lc03_input_mode_07;
      38: result:=lc03_input_mode_08;
      39: result:=lc03_input_mode_09;
    else
      result:=0;
    end_case;
    
  end;
  function read_output(i:int):int; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    x: bool;
    w: int;
  var_end;

  begin
    
    // read a single output
    //
    // output 0..39: 0-off, 1-on
    // dimmer 40..55: 0..100
    // blinds 56..65: 0..100
    //
    // return value -1 means general error
    
    // input mux
    
    case i of
       0: x:=lc00_qx00;
       1: x:=lc00_qx01;
       2: x:=lc00_qx02;
       3: x:=lc00_qx03;
       4: x:=lc00_qx04;
       5: x:=lc00_qx05;
       6: x:=lc00_qx06;
       7: x:=lc00_qx07;
       8: x:=lc00_qx08;
       9: x:=lc00_qx09;
    
      10: x:=lc01_qx00;
      11: x:=lc01_qx01;
      12: x:=lc01_qx02;
      13: x:=lc01_qx03;
      14: x:=lc01_qx04;
      15: x:=lc01_qx05;
      16: x:=lc01_qx06;
      17: x:=lc01_qx07;
      18: x:=lc01_qx08;
      19: x:=lc01_qx09;
    
      20: x:=lc02_qx00;
      21: x:=lc02_qx01;
      22: x:=lc02_qx02;
      23: x:=lc02_qx03;
      24: x:=lc02_qx04;
      25: x:=lc02_qx05;
      26: x:=lc02_qx06;
      27: x:=lc02_qx07;
      28: x:=lc02_qx08;
      29: x:=lc02_qx09;
    
      30: x:=lc03_qx00;
      31: x:=lc03_qx01;
      32: x:=lc03_qx02;
      33: x:=lc03_qx03;
      34: x:=lc03_qx04;
      35: x:=lc03_qx05;
      36: x:=lc03_qx06;
      37: x:=lc03_qx07;
      38: x:=lc03_qx08;
      39: x:=lc03_qx09;
    
      40: w:=ld00_qw00; x:=ld00_qx00;
      41: w:=ld00_qw01; x:=ld00_qx01;
      42: w:=ld00_qw02; x:=ld00_qx02;
      43: w:=ld00_qw03; x:=ld00_qx03;
    
      44: w:=ld01_qw00; x:=ld01_qx00;
      45: w:=ld01_qw01; x:=ld01_qx01;
      46: w:=ld01_qw02; x:=ld01_qx02;
      47: w:=ld01_qw03; x:=ld01_qx03;
    
      48: w:=ld02_qw00; x:=ld02_qx00;
      49: w:=ld02_qw01; x:=ld02_qx01;
      50: w:=ld02_qw02; x:=ld02_qx02;
      51: w:=ld02_qw03; x:=ld02_qx03;
    
      52: w:=ld03_qw00; x:=ld03_qx00;
      53: w:=ld03_qw01; x:=ld03_qx01;
      54: w:=ld03_qw02; x:=ld03_qx02;
      55: w:=ld03_qw03; x:=ld03_qx03;
    
      56: w:=bc00_blinds_setpoint_00; x:=bc00_qxs00_up;
      57: w:=bc00_blinds_setpoint_01; x:=bc00_qxs01_up;
      58: w:=bc00_blinds_setpoint_02; x:=bc00_qxs02_up;
      59: w:=bc00_blinds_setpoint_03; x:=bc00_qxs03_up;
      60: w:=bc00_blinds_setpoint_04; x:=bc00_qxs04_up;
    
      61: w:=bc01_blinds_setpoint_00; x:=bc01_qxs00_up;
      62: w:=bc01_blinds_setpoint_01; x:=bc01_qxs01_up;
      63: w:=bc01_blinds_setpoint_02; x:=bc01_qxs02_up;
      64: w:=bc01_blinds_setpoint_03; x:=bc01_qxs03_up;
      65: w:=bc01_blinds_setpoint_04; x:=bc01_qxs04_up;
    end_case;
    
    // process bit/word value
    
    if i<=39 then
      if x>=2 then result:=-1; else result:=x; end_if; // lc
    else
      if x>=2 then result:=-1; else result:=w; end_if; // ld and bc
    end_if;
    
  end;
  function write_output(i,j:int):void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    x: bool;
    w: int;
  var_end;

  begin
    
    // write a single output
    //
    // output 0..39: 0-off, 1-on
    // dimmer 40..55: 0..100
    // blinds 56..65: 0..100
    
    // process bit/word value
    
    if i<=39 then
      x:=j<>0;
    else
      w:=j;
    end_if;
    
    // output mux
    
    case i of
       0: lc00_qx00:=x;
       1: lc00_qx01:=x;
       2: lc00_qx02:=x;
       3: lc00_qx03:=x;
       4: lc00_qx04:=x;
       5: lc00_qx05:=x;
       6: lc00_qx06:=x;
       7: lc00_qx07:=x;
       8: lc00_qx08:=x;
       9: lc00_qx09:=x;
    
      10: lc01_qx00:=x;
      11: lc01_qx01:=x;
      12: lc01_qx02:=x;
      13: lc01_qx03:=x;
      14: lc01_qx04:=x;
      15: lc01_qx05:=x;
      16: lc01_qx06:=x;
      17: lc01_qx07:=x;
      18: lc01_qx08:=x;
      19: lc01_qx09:=x;
    
      20: lc02_qx00:=x;
      21: lc02_qx01:=x;
      22: lc02_qx02:=x;
      23: lc02_qx03:=x;
      24: lc02_qx04:=x;
      25: lc02_qx05:=x;
      26: lc02_qx06:=x;
      27: lc02_qx07:=x;
      28: lc02_qx08:=x;
      29: lc02_qx09:=x;
    
      30: lc03_qx00:=x;
      31: lc03_qx01:=x;
      32: lc03_qx02:=x;
      33: lc03_qx03:=x;
      34: lc03_qx04:=x;
      35: lc03_qx05:=x;
      36: lc03_qx06:=x;
      37: lc03_qx07:=x;
      38: lc03_qx08:=x;
      39: lc03_qx09:=x;
    
      40: ld00_qw00:=w;
      41: ld00_qw01:=w;
      42: ld00_qw02:=w;
      43: ld00_qw03:=w;
    
      44: ld01_qw00:=w;
      45: ld01_qw01:=w;
      46: ld01_qw02:=w;
      47: ld01_qw03:=w;
    
      48: ld02_qw00:=w;
      49: ld02_qw01:=w;
      50: ld02_qw02:=w;
      51: ld02_qw03:=w;
    
      52: ld03_qw00:=w;
      53: ld03_qw01:=w;
      54: ld03_qw02:=w;
      55: ld03_qw03:=w;
    
      56: bc00_blinds_setpoint_00:=w;
      57: bc00_blinds_setpoint_01:=w;
      58: bc00_blinds_setpoint_02:=w;
      59: bc00_blinds_setpoint_03:=w;
      60: bc00_blinds_setpoint_04:=w;
    
      61: bc01_blinds_setpoint_00:=w;
      62: bc01_blinds_setpoint_01:=w;
      63: bc01_blinds_setpoint_02:=w;
      64: bc01_blinds_setpoint_03:=w;
      65: bc01_blinds_setpoint_04:=w;
    end_case;
    
  end;
  function toggle_output(i:int):void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    j: int;
  var_end;

  begin
    
    // toggle specified output (0..55)
    
    j:=read_output(i);
    
    if j==0 then
      write_output(i,100);
    elsif j<>-1 then
      write_output(i,0);
    end_if;
    
  end;
  function custom_algo:void; language 'Structured Text';
  begin
    
    // here is the right place for custom modifications
    
  end;
begin
  
  clear_algo(); // clear missing modules
  
  light_algo(); // light functions
  input_algo(); // process input keys
  scene_algo(); // scene releted requests
  remote_algo(); // remote controller
  ready_light(); // automatic lights
  
  hvac_algo(); // heating and cooling
  timetable_algo(); // timetable handling
  low_light_algo(); // low light indicator
  presence_algo(); // presence indicator
  automation_algo(); // events and tasks
  
  alarm_algo(); // burglar alarm
  energy_algo(); // energy consumption
  socket_algo(); // cybro-cybro communication
  system_algo(); // system-related tasks
  
  custom_algo(); // placeholder for custom tasks
  
end;
#CODE_END

#DESCRIPTION_BEGIN
#DESCRIPTION_END

##PROGRAM_END_1

